//obsluha zalozky pro upravu parametru prvku
const PARAM_SEPARATOR=': ';
      PARAM_NOCHANGE='&NOCHANGE&';
      
var iEditCommand,iEditCmdPar,iEditTemplate:integer;
    tText:TEdit;
    tSeznam:TListBox;

function FillColorsetString:string;
var i:integer;
begin
  Result:='';
    for i:=0 to naColorset-1 do begin Result:=Result+aColorset[i].sName+','; end;
end;

function FillTagString:string;
var i:integer;
begin
  Result:='';
    for i:=0 to naTag-1 do begin Result:=Result+aTag[i].sNameGgs+','; end;
end;

function FillNumbersString:string;
var i:integer;
begin
  //pridava seznam definovanych TAGu (mezi enum polozky)
  Result:='';
  if(aNumbers<>nil) then begin
    for i:=0 to aNumbers.Count-1 do begin
      Result:=Result+aNumbers[i]+','; //prepsat jmeno
      i:=i+4; //preskocit pojmenovani a obsah obou sloupcu
    end;
  end;
end;

procedure FillColorset(list:TListBox);
var i:integer;
begin
  for i:=0 to naColorset-1 do begin list.Items.Add(aColorset[i].sName); end;
end;

procedure FillTag(list:TListBox);
var i:integer;
begin
  //pridava seznam definovanych TAGu (mezi enum polozky)
  for i:=0 to naTag-1 do begin list.Items.Add(aTag[i].sNameGgs); end;
ShowMessage('PPPPP konec FillNumbers');
end;

procedure FillNumbers(list:TListBox);
var i:integer;
begin
  //pridava seznam definovanych TAGu (mezi enum polozky)
  if(aNumbers<>nil) then begin
    for i:=0 to aNumbers.Count-1 do begin
      list.Items.Add(aNumbers[i]); //prepsat jmeno
      i:=i+4; //preskocit pojmenovani a obsah obou sloupcu
    end;
  end;
end;

procedure FillEnum;
var s,s1:string;
begin
  FormMain_EditEnumListEnum.Clear();
  //ShowMessage('HHHHH pocet hodnot parametru='+IntToStr(aCmdPar[iEditCmdPar].aValues.Count));
  s:=aCmdPar[iEditCmdPar].aValues[FormMain_EditListParam.ItemIndex];
  while (s<>'') do begin
    s1:=fetch(s,',');
    if(s1='&TAG&') then FillTag(FormMain_EditEnumListEnum)
    else if(s1='&NUMBERS&') then FillNumbers(FormMain_EditEnumListEnum)
    else if(s1='&COLORSET&') then FillColorset(FormMain_EditEnumListEnum)
    else FormMain_EditEnumListEnum.Items.Add(s1);
  end;
end;

function TestCommand(index:integer):boolean; //test parametru prikazu
var i,iCmdPar:Integer;
    s,par,enum,typ,sErr:string;
begin
  sErr:='';
  iCmdPar:=aCommand[index].iCmdPar;
  if(aCmdPar[iCmdPar].iParams[0]<1) and (aCmdPar[iCmdPar].iParams[1]<1)
    and (aCommand[index].sParam<>'') then  sErr:=sErr+'Pebyten parametr'+CRLF;
  par:=aCommand[index].sParam;
  {
  ShowMessage('XXXXX cmd='+aCmdPar[iCmdPar].sCommand+'/'+aCommand[index].sCommand+CRLF
    +'index='+IntToStr(index)+CRLF
    +'iCmdPar='+IntToStr(iCmdPar)+CRLF
    +'iParams='+IntToStr(aCmdPar[iCmdPar].iParams[0])+'/'+IntToStr(aCmdPar[iCmdPar].iParams[1])+CRLF
    //+'types='+aCmdPar[iCmdPar].aParamTypes[0]+CRLF
    +'par='+par);
  }
  for i:=1 to aCmdPar[iCmdPar].iParams[1] do begin
    if(par='') and (i>aCmdPar[iCmdPar].iParams[0]) then i:=aCmdPar[iCmdPar].iParams[1]
    else begin
      //prepsat parametr, typ a pripadne povolene hodnoty
      typ:=aCmdPar[iCmdPar].aParamTypes[i-1];
      enum:=aCmdPar[iCmdPar].aValues[i-1];
      //COLORSET musime obslouzit nastavenim hodnot jinak
      if(aCmdPar[iCmdPar].sCommand='#==#_COLORSET') then begin
        typ:='enum';
        enum:='&COLORSET&';
      end;
//ShowMessage('LLLLL 5 enum='+enum);
      if(enum<>'') then begin
        enum:=ReplaceString(enum,'&TAG&',FillTagString());
        enum:=ReplaceString(enum,'&NUMBERS&',FillNumbersString());
        enum:=ReplaceString(enum,'&COLORSET&',FillColorsetString());
      end;
//ShowMessage('LLLLL 6');
      if(i<aCmdPar[iCmdPar].iParams[1]) then s:=fetch(par,' ')
      else s:=trim(par);
      if(s='') and (i<=aCmdPar[iCmdPar].iParams[0]) then
        sErr:=sErr+IntToStr(i)+'. parametr neobsahuje dnou hodnotu'+CRLF
      else case typ of //otestujeme parametr
      'string':;
      'word': begin if(RegexSubstitute('.*(\s*).*',s,'$1')<>'') then sErr:=sErr+IntToStr(i)+'. parametr ('+s+') obsahuje mezeru nebo jin bl znak'+CRLF; end;
      'int': begin  if(RegexSubstitute('.*([^0-9]+).*',s,'$1')<>'') then sErr:=sErr+IntToStr(i)+'. parametr ('+s+') obsahuje neseln znak'+CRLF; end;
      'real': begin  if(RegexSubstitute('.*([^0-9.]+).*',s,'$1')<>'') then sErr:=sErr+IntToStr(i)+'. parametr ('+s+') obsahuje neseln znak'+CRLF; end;
      'rgb': begin  if(RegexSubstitute('.*([^0-9A-Fa-f]*).*',s,'$1')<>'') then sErr:=sErr+IntToStr(i)+'. parametr ('+s+') neobsahuje RGB kod barvy'+CRLF; end;
      'enum': begin
                //obslouzime
                if(pos(s,enum)<=0) then begin
                  sErr:=sErr+IntToStr(i)+'. parametr ('+s+') obsahuje nepovolenou hodnotu'+CRLF;
                  {
                  ShowMessage('JJJJJ cmd='+aCmdPar[iCmdPar].sCommand+CRLF
                    +'index='+IntToStr(index)+CRLF
                    +'iCmdPar='+IntToStr(iCmdPar)+CRLF
    +'iParams='+IntToStr(aCmdPar[iCmdPar].iParams[0])+'/'+IntToStr(aCmdPar[iCmdPar].iParams[1])+CRLF
                    +'typ='+typ+CRLF
                    +'par='+par+CRLF
                    +'s='+s+CRLF
                    );
                  }
                end;
              end;
      end; //konec case
      //COLORSET musime ukoncit, ve skutecnosti ma jediny parametr
      if(aCmdPar[iCmdPar].sCommand='#==#_COLORSET') then i:=aCmdPar[iCmdPar].iParams[1];
    end;
  end;
//ShowMessage('LLLLL 8');
  aCommand[index].sError:=sErr;
  Result:=(sErr='');
end;

procedure EditListParamOnClick(sender:TObject);
var sTabName:string;
    i:integer;
begin
  if(FormMain_EditListParam.ItemIndex>-1) then begin
    FormMain_EditButUse.Enabled:=false;
    i:=FormMain_EditListParam.ItemIndex;
    //zobrazime nebo skryjeme promenne GgStatu
    sTabName:=copy(aCmdPar[iEditCmdPar].sGsVariables,i+1,1);
    FormMain_EditListVars.Visible:=(sTabName='Y');
    FormMain_EditLabelVars.Visible:=(sTabName='Y');
    //podle typu parametru naplnime text k editaci/vyberu a vyberem spravnou zalozku
    case aCmdPar[iEditCmdPar].aParamTypes[FormMain_EditListParam.ItemIndex] of
    'string': begin sTabName:='String'; FormMain_EditTextEditText.Text:=aEditParams[i]; tText:=FormMain_EditTextEditText; tSeznam:=nil; end;
    'word':   begin sTabName:='Word'; FormMain_EditWordEditWord.Text:=aEditParams[i]; tText:=FormMain_EditWordEditWord; tSeznam:=nil; end;
    'int':    begin sTabName:='Int'; FormMain_EditIntEditInt.Text:=aEditParams[i]; tText:=FormMain_EditIntEditInt; tSeznam:=nil; end;
    'real':   begin sTabName:='Real'; tSeznam:=nil; FormMain_EditRealEditReal.Text:=aEditParams[i]; end;
    'cacheType':begin sTabName:='CacheType'; tText:=nil; tSeznam:=FormMain_EditCacheListCache; end;
    'cacheID':  begin sTabName:='CacheId'; FormMain_EditCacheidEditCacheid.Text:=aEditParams[i]; tText:=FormMain_EditCacheidEditCacheid; tSeznam:=nil; end;
    'enum':   begin sTabName:='Enum'; FillEnum(); tText:=nil; tSeznam:=FormMain_EditEnumListEnum; end;
    'RGB':    begin sTabName:='RGB'; tText:=FormMain_EditRgbEditRgb; tSeznam:=nil; tText.Visible:=false; end;
    'file':   begin sTabName:='File'; FormMain_EditFileEditFile.Text:=aEditParams[i]; tText:=nil; tSeznam:=nil; end;
    end;
    if(sTabName='') then ShowMessage('ERROR: Chybny typ parametru: '+aCmdPar[iEditCmdPar].aParamTypes[FormMain_EditListParam.ItemIndex])
    else begin
      sTabName:='EditTab'+sTabName;
      ShowPage(FormMain_EditPagesParam,sTabName);
    end;
  end;
end;

procedure EditListVarsOnDblClick(sender:TObject);
var s,s1:string;
    i:integer;
begin
  i:=FormMain_EditListVars.ItemIndex;
  if(i>-1) and (tText<>nil) then begin
    s:=FormMain_EditListVars.Items[i];
    s1:=fetch(s,' ');
    s:=tText.Text;
    s:=copy(s,1,FormMain_EditTextEditText.SelStart) //cast pred kurzorem
       +s1 //vlozime promennou, vynechame oznaceny blok
       +copy(s,1+FormMain_EditTextEditText.SelStart+FormMain_EditTextEditText.SelLength,length(s));
    tText.Text:=s;
  end;
end;

procedure EditButCancelOnClick(sender:TObject);
begin
  ShowPage(FormMain_Pages,'TabUvod');
end;

procedure EditButUseParamOnClick(sender:TObject);
var i:integer;
    s,s1,s2:string;
begin
  i:=FormMain_EditListParam.ItemIndex;
  s:='';
  if(i>-1) then begin
    if(tText<>nil) then s:=tText.text
    else if(tSeznam<>nil) then begin
      {
      if(tSeznam.ItemIndex>=tSeznam.Items.Count) then s:=tSeznam.Items[tSeznam.Items.Count-1]
      else
      }
      if(tSeznam.ItemIndex>-1) then s:=tSeznam.Items[tSeznam.ItemIndex]
      else s:=PARAM_NOCHANGE;
    end;
    if(s<>PARAM_NOCHANGE) then begin
      s1:=FormMain_EditListParam.Items[FormMain_EditListParam.ItemIndex];
      s2:=fetch(s1,PARAM_SEPARATOR)+PARAM_SEPARATOR+s;
      FormMain_EditListParam.Items[FormMain_EditListParam.ItemIndex]:=s2;
      FormMain_EditButUse.Enabled:=true; //zpristupnime tlacitko OK
    end;
  end;
end;

procedure EditButUseOnClick(sender:TObject); //ulozi zmenene parametry
var i:integer;
    s,s1,s2:string;
begin
  s:=''
  for i:=0 to aCmdPar[iEditCmdPar].iParams[1]-1 do begin //zkonstruujeme radek s parametry
    s1:=FormMain_EditListParam.Items[i];
    s2:=fetch(s1,PARAM_SEPARATOR);
    s:=s+' '+s1;
  end;
  s:=Trim(s);
  //s2:=aCommand[iEditCommand].sParam;
  aCommand[iEditCommand].sParam:=s;    //prepsat do seznamu prikazu
  FormMain_UvodListTemplate.Items[FormMain_UvodListTemplate.ItemIndex]:=
    aCommand[iEditCommand].sCommand+' '+s;
  if(TestCommand(iEditCommand)=false) then begin
    ShowMessage('ERROR: chybne hodnoty parametru:'+CRLF+aCommand[iEditCommand].sError);
    //aCommand[iEditCommand].sParam:=s2;
  end
  else begin
    ShowPage(FormMain_Pages,'TabUvod');   //skryt tuto zalozku a prepnout na zalozku se seznamem prikazu
    OnFileChange(); //poznacime zmenu v souboru
  end;
end;

procedure InitEdit;
begin
  FormMain_EditListParam.OnClick:=@EditListParamOnClick;
  FormMain_EditButUse.OnClick:=@EditButUseOnClick;
  FormMain_EditButCancel.OnClick:=@EditButCancelOnClick;
  FormMain_EditButUseParam.OnClick:=@EditButUseParamOnClick;
  FormMain_EditListVars.OnDblClick:=@EditListVarsOnDblClick;
end;

procedure InitEditParam; //pripravi k editaci parametry vybraneho prikazu
var i:Integer;
    s,s1,sParam:string;
begin
  InitEdit(); //inicializace obsluhy formulare
  iEditTemplate:=FormMain_UvodListTemplate.ItemIndex;
  if(iEditTemplate>-1) then begin //nacteme seznam parametru prikazu
    FormMain_EditListParam.Clear;
    iEditCommand:=aIndexCommand[iEditTemplate];
    iEditCmdPar:=aCommand[iEditCommand].iCmdPar;
    if(aCmdPar[iEditCmdPar].iParams[1]>0) then begin
      if(aEditParams=nil) then aEditParams:=TStringList.Create()
      else aEditParams.Clear();
      //ShowMessage('SSSSS 1 Parametru: '+IntToStr(aCmdPar[iEditCmdPar].iParams[0])+'/'+IntToStr(aCmdPar[iEditCmdPar].iParams[1]));
      sParam:=aCommand[iEditCommand].sParam;
      for i:=0 to aCmdPar[iEditCmdPar].iParams[1]-1 do begin
        s:=aCmdPar[iEditCmdPar].aParamNames[i];
        if(i=aCmdPar[iEditCmdPar].iParams[1]-1) then s1:=sParam //hodnota parametru
        else s1:=fetch(sParam,' ');
        aEditParams.Add(s1);    //pridame ji do pole
        FormMain_EditListParam.Items.Add(s+PARAM_SEPARATOR+s1); //a k vypisu
      end;
      if(FormMain_EditListParam.Items.Count>0) then FormMain_EditListParam.ItemIndex:=0;
      FormMain_EditLabelCmd.Caption:=aCommand[iEditCommand].sCommand;
      EditListParamOnClick(nil);             //vyvolame kliknuti
    end;
    //pro DEFINE_DATASET je vysledek mozna spatny, protoze typ kese muze mit vic
    //  slov. Upravime to.
    if(aCmdPar[iEditCmdPar].sCommand='DEFINE_DATASET') then begin
      sParam:=aCommand[iEditCommand].sParam;
      s:=fetch(sParam,' ');
      s1:=fetch(sParam,' '); //2. parametr
      if(sParam<>'') then begin
        s:=s+' '+s1;
        FormMain_EditListParam.Items[0]:=aCmdPar[iEditCmdPar].aParamNames[0]+PARAM_SEPARATOR+s;
        FormMain_EditListParam.Items[1]:=aCmdPar[iEditCmdPar].aParamNames[1]+PARAM_SEPARATOR+sParam;
      end;
    end;
  end;
end;
