// zalozka pro definici radku v tabulce zajimavych cisel

function FindIndexNumbersFromName(sName:string):Integer;
var i:integer;
begin
  Result:=-1;
  for i:=0 to aNumbers.Count-1 do begin
    if(aNumbers[i]=sName) then begin
      Result:=i/5;
      i:=aNumbers.Count-1;
    end
    else i:=i+4;
  end;
end;

procedure NumbersEnableButtons;
var b:boolean;
begin
  b:=true;
  if(FormMain_NumbersEditName.Text='') then b:=false;
  if(FormMain_NumbersEditContentLeft.Text='') then b:=false;
  if(FormMain_NumbersEditContentRight.Text='') then b:=false;
  if(b=false) then begin    //pokud je true, nechame beze zmeny
    FormMain_NumbersButAdd.Enabled:=b;
    FormMain_NumbersButChange.Enabled:=b;
  end;
  FormMain_NumbersButAddLeft.Enabled:=(FormMain_NumbersListVars.ItemIndex>-1);
  FormMain_NumbersButAddRight.Enabled:=(FormMain_NumbersListVars.ItemIndex>-1);
  FormMain_NumbersButDel.Enabled:=(FormMain_NumbersListNumbers.ItemIndex>-1);
  
end;

procedure NumbersListNumbersOnClick(sender:TObject);
var i:Integer;
begin
  i:=FormMain_NumbersListNumbers.ItemIndex;
  if(i>-1) then begin
    i:=i*5; //index parametru teto definice
    FormMain_NumbersEditName.Text:=aNumbers[i];
    FormMain_NumbersEditNameLeft.Text:=aNumbers[i+1];
    FormMain_NumbersEditContentLeft.Text:=aNumbers[i+2];
    FormMain_NumbersEditNameRight.Text:=aNumbers[i+3];
    FormMain_NumbersEditContentRight.Text:=aNumbers[i+4];
  end;
  FormMain_NumbersButAdd.Enabled:=false;
  FormMain_NumbersButChange.Enabled:=false;
  NumbersEnableButtons;
end;

procedure NumbersToList;
var i:Integer;
begin
  //naplnime seznam radku
  FormMain_NumbersListNumbers.Items.Clear();
  for i:=0 to aNumbers.Count-1 do begin
    FormMain_NumbersListNumbers.Items.Add(aNumbers[i]);
    i:=i+4; //preskocit definice sloupcu
  end;
  if(aNumbers.Count>0) then FormMain_NumbersListNumbers.ItemIndex:=0
  else begin
    FormMain_NumbersListNumbers.Items.Clear();
    FormMain_NumbersListNumbers.ItemIndex:=-1;
  end;
  NumbersListNumbersOnClick(nil);
end;

procedure SetEmptyNames;
begin
  if(FormMain_NumbersEditNameLeft.Text='') then
    FormMain_NumbersEditNameLeft.Text:=FormMain_NumbersEditName.Text+'_Header';
  if(FormMain_NumbersEditNameRight.Text='') then
    FormMain_NumbersEditNameRight.Text:=FormMain_NumbersEditName.Text+'_Value';
  //mezery nahradime podtrzitky
  FormMain_NumbersEditName.Text:=ReplaceString(FormMain_NumbersEditName.Text,' ','_');
  FormMain_NumbersEditNameLeft.Text:=ReplaceString(FormMain_NumbersEditNameLeft.Text,' ','_');
  FormMain_NumbersEditNameRight.Text:=ReplaceString(FormMain_NumbersEditNameRight.Text,' ','_');
end;

procedure NumbersButChangeOnClick(sender:TObject);
var i:Integer; //zaroven nastavit priznak zmeny v souboru (asi v tom s hlavnim prikazem, ale co kdyz jeste neni?)
begin
  i:=FormMain_NumbersListNumbers.ItemIndex;
  if(i>-1) then begin
    i:=i*5;
    SetEmptyNames();
    aNumbers[i]:=FormMain_NumbersEditName.Text;
    aNumbers[i+1]:=FormMain_NumbersEditNameLeft.Text;
    aNumbers[i+2]:=FormMain_NumbersEditContentLeft.Text;
    aNumbers[i+3]:=FormMain_NumbersEditNameRight.Text;
    aNumbers[i+4]:=FormMain_NumbersEditContentRight.Text;
    NumbersListNumbersOnClick(nil);
    FormMain_NumbersButChange.Enabled:=false;
    FormMain_NumbersButAdd.Enabled:=false;
  end;
end;

procedure NumbersButAddOnClick(sender:TObject);
//var i:Integer; //zaroven nastavit priznak zmeny v souboru (asi v tom s hlavnim prikazem, ale co kdyz jeste neni?)
begin
  SetEmptyNames();
  aNumbers.Add(FormMain_NumbersEditName.Text);
  aNumbers.Add(FormMain_NumbersEditNameLeft.Text);
  aNumbers.Add(FormMain_NumbersEditContentLeft.Text);
  aNumbers.Add(FormMain_NumbersEditNameRight.Text);
  aNumbers.Add(FormMain_NumbersEditContentRight.Text);
  FormMain_NumbersListNumbers.Items.Add(FormMain_NumbersEditName.Text);
  FormMain_NumbersListNumbers.ItemIndex:=FormMain_NumbersListNumbers.Items.Count-1;
  FormMain_NumbersButChange.Enabled:=false;
  FormMain_NumbersButAdd.Enabled:=false;
  NumbersListNumbersOnClick(nil);
end;

procedure NumbersButDelOnClick(sender:TObject);
var i:Integer; //zaroven nastavit priznak zmeny v souboru (asi v tom s hlavnim prikazem, ale co kdyz jeste neni?)
begin
  //zkontrolovat, zda se nepouziva v nekterem z prikazu APPEND_NUMBERS
  i:=FormMain_NumbersListNumbers.ItemIndex;
  if(i>-1) then begin
    FormMain_NumbersListNumbers.Items.Delete(i);
    i:=i*5;
    aNumbers.Delete(i); aNumbers.Delete(i); aNumbers.Delete(i); aNumbers.Delete(i); aNumbers.Delete(i);
    i:=trunc(i/5);
    if(i>FormMain_NumbersListNumbers.Items.Count-1) then i:=i-1;
    FormMain_NumbersListNumbers.ItemIndex:=i;
    FormMain_NumbersButChange.Enabled:=false;
    FormMain_NumbersButAdd.Enabled:=false;
    NumbersListNumbersOnClick(nil);
  end;
end;

procedure NumbersButAddLeftOnClick(sender:TObject);
begin   //zaroven nastavit priznak zmeny v souboru (asi v tom s hlavnim prikazem, ale co kdyz jeste neni?)
end;

procedure NumbersButAddRightOnClick(sender:TObject);
begin   //zaroven nastavit priznak zmeny v souboru (asi v tom s hlavnim prikazem, ale co kdyz jeste neni?)
end;

procedure NumbersEditOnCange(sender:TObject);
begin   //zaroven nastavit priznak zmeny v souboru (asi v tom s hlavnim prikazem, ale co kdyz jeste neni?)
  if(sender=FormMain_NumbersEditName) then FormMain_NumbersButAdd.Enabled:=true;
  FormMain_NumbersButChange.Enabled:=true;
end;

procedure InitNumbers;
begin
  FormMain_NumbersListNumbers.OnClick:=@NumbersListNumbersOnClick;
  FormMain_NumbersButChange.OnClick:=@NumbersButChangeOnClick;
  FormMain_NumbersButAdd.OnClick:=@NumbersButAddOnClick;
  FormMain_NumbersButDel.OnClick:=@NumbersButDelOnClick;
  FormMain_NumbersButAddLeft.OnClick:=@NumbersButAddLeftOnClick;
  FormMain_NumbersButAddRight.OnClick:=@NumbersButAddRightOnClick;
  FormMain_NumbersEditName.OnChange:=@NumbersEditOnCange;
  FormMain_NumbersEditNameLeft.OnChange:=@NumbersEditOnCange;
  FormMain_NumbersEditContentLeft.OnChange:=@NumbersEditOnCange;
  FormMain_NumbersEditNameRight.OnChange:=@NumbersEditOnCange;
  FormMain_NumbersEditContentRight.OnChange:=@NumbersEditOnCange;
end;
