//obsluha zalozky pro nastaveni barev + funkce pro praci s barevnymi sadami
const COLOR_INDEX_MainBg=0; COLOR_INDEX_MainText=1;
      COLOR_INDEX_TitleBg=2; COLOR_INDEX_TitleText=3;
      COLOR_INDEX_HeaderBg=4; COLOR_INDEX_HeaderText=5;
      COLOR_INDEX_BlockBg=6; COLOR_INDEX_BlockText=7;
      COLOR_INDEX_ValueBg=8; COLOR_INDEX_ValueText=9;
      COLOR_INDEX_ValueMax=10;  COLOR_INDEX_ValueAvg=11; COLOR_INDEX_ValueMin=12;
      COLOR_INDEX_ValuePerc=13;


var //aiColorset:array[0..COLOR_INDEX_ValuePerc] of integer;
    aiColorsetSwap:array[0..COLOR_INDEX_ValuePerc] of integer;
    bColorChange:boolean;

function IntToHex(iNum,len:integer):string;
var iByte:byte;
    s:string;
begin
  s:='0123456789ABCDEF';
  Result:='';
  while(iNum<>0) do begin
    iByte:=iNum mod 16;
    Result:=copy(s,1+iByte,1)+Result;
    iNum:=trunc(iNum/16);
  end;
  if(length(Result)<len) then Result:=copy('00000000',1,len-length(Result))+Result
  else if(length(Result)>len) then Result:=copy(Result,1,len);
end;

procedure ColorEnableButtons;
begin
  FormMain_BarvyButChange.Enabled:=bColorChange;
  FormMain_BarvyButDel.Enabled:=(FormMain_BarvyList.ItemIndex>-1);
end;

procedure ShowColors;  //zobrazi podklad spravnych napisu ve spravnych barvach
begin
  FormMain_BarvyLabelMainBg.Color:=aiColorsetSwap[COLOR_INDEX_MainBg];
    FormMain_BarvyLabelMainBg.Font.Color:=aiColorsetSwap[COLOR_INDEX_MainText];
  FormMain_BarvyLabelMainText.Color:=aiColorsetSwap[COLOR_INDEX_MainText];
    FormMain_BarvyLabelMainText.Font.Color:=aiColorsetSwap[COLOR_INDEX_MainBg];
  FormMain_BarvyLabelTitleBg.Color:=aiColorsetSwap[COLOR_INDEX_TitleBg];
    FormMain_BarvyLabelTitleBg.Font.Color:=aiColorsetSwap[COLOR_INDEX_TitleText];
  FormMain_BarvyLabelTitleText.Color:=aiColorsetSwap[COLOR_INDEX_TitleText];
    FormMain_BarvyLabelTitleText.Font.Color:=aiColorsetSwap[COLOR_INDEX_TitleBg];
  FormMain_BarvyLabelHeaderBg.Color:=aiColorsetSwap[COLOR_INDEX_HeaderBg];
    FormMain_BarvyLabelHeaderBg.Font.Color:=aiColorsetSwap[COLOR_INDEX_HeaderText];
  FormMain_BarvyLabelHeaderText.Color:=aiColorsetSwap[COLOR_INDEX_HeaderText];
    FormMain_BarvyLabelHeaderText.Font.Color:=aiColorsetSwap[COLOR_INDEX_HeaderBg];
  FormMain_BarvyLabelBlockBg.Color:=aiColorsetSwap[COLOR_INDEX_BlockBg];
    FormMain_BarvyLabelBlockBg.Font.Color:=aiColorsetSwap[COLOR_INDEX_BlockText];
  FormMain_BarvyLabelBlockText.Color:=aiColorsetSwap[COLOR_INDEX_BlockText];
    FormMain_BarvyLabelBlockText.Font.Color:=aiColorsetSwap[COLOR_INDEX_BlockBg];
  FormMain_BarvyLabelValueBg.Color:=aiColorsetSwap[COLOR_INDEX_ValueBg];
    FormMain_BarvyLabelValueBg.Font.Color:=aiColorsetSwap[COLOR_INDEX_ValueText];
  FormMain_BarvyLabelValueText.Color:=aiColorsetSwap[COLOR_INDEX_ValueText];
    FormMain_BarvyLabelValueText.Font.Color:=aiColorsetSwap[COLOR_INDEX_ValueBg];
  FormMain_BarvyLabelValueMax.Color:=aiColorsetSwap[COLOR_INDEX_ValueMax];
    FormMain_BarvyLabelValueMax.Font.Color:=aiColorsetSwap[COLOR_INDEX_ValueText];
  FormMain_BarvyLabelValueAvg.Color:=aiColorsetSwap[COLOR_INDEX_ValueAvg];
    FormMain_BarvyLabelValueAvg.Font.Color:=aiColorsetSwap[COLOR_INDEX_ValueText];
  FormMain_BarvyLabelValueMin.Color:=aiColorsetSwap[COLOR_INDEX_ValueMin];
    FormMain_BarvyLabelValueMin.Font.Color:=aiColorsetSwap[COLOR_INDEX_ValueText];
  FormMain_BarvyLabelValuePerc.Color:=aiColorsetSwap[COLOR_INDEX_ValuePerc];
    FormMain_BarvyLabelValuePerc.Font.Color:=aiColorsetSwap[COLOR_INDEX_ValueText];
  ColorEnableButtons();
end;

function SwapRB(RGB:string): string;
var s1,s2,s3:string;
begin
  s1:=copy(RGB,1,2);
  s2:=copy(RGB,3,2);
  s3:=copy(RGB,5,2);
  Result:=s3+s2+s1;
end;

procedure ColorOnClick(sender:TObject);
var cd: TColorDialog;
    i:integer;
begin
  cd:=TColorDialog.create(nil);
  i:=-1;
  case sender of
    FormMain_BarvyLabelMainBg: i:=COLOR_INDEX_MainBg;
    FormMain_BarvyLabelMainText: i:=COLOR_INDEX_MainText;
    FormMain_BarvyLabelTitleBg: i:=COLOR_INDEX_TitleBg;
    FormMain_BarvyLabelTitleText: i:=COLOR_INDEX_TitleText;
    FormMain_BarvyLabelHeaderBg: i:=COLOR_INDEX_HeaderBg;
    FormMain_BarvyLabelHeaderText: i:=COLOR_INDEX_HeaderText;
    FormMain_BarvyLabelBlockBg: i:=COLOR_INDEX_BlockBg;
    FormMain_BarvyLabelBlockText: i:=COLOR_INDEX_BlockText;
    FormMain_BarvyLabelValueBg: i:=COLOR_INDEX_ValueBg;
    FormMain_BarvyLabelValueText: i:=COLOR_INDEX_ValueText;
    FormMain_BarvyLabelValueMax: i:=COLOR_INDEX_ValueMax;
    FormMain_BarvyLabelValueAvg: i:=COLOR_INDEX_ValueAvg;
    FormMain_BarvyLabelValueMin: i:=COLOR_INDEX_ValueMin;
    FormMain_BarvyLabelValuePerc: i:=COLOR_INDEX_ValuePerc;
  end;
  if(i<0) then cd.Color:=StrToInt('$ffffff')
  else begin
    cd.Color:=aiColorsetSwap[i];
    cd.Options:=[cdFullOpen];
  end;
  try
    if(i<0) then begin if(cd.Execute()) then showmessage('SSSSS : '+inttostr(cd.color)); end
    else if(cd.Execute) then begin
      //aiColorset[i]:=cd.Color;
      //aiColorset[i]:=StrToInt('$'+SwapRB(IntToHex(cd.Color,6)));
      aiColorsetSwap[i]:=cd.Color;
      bColorChange:=true;
      ShowColors();
    end;
  finally
    cd.free;
  end;
end;

procedure NameOnChange(sender:TObject);
begin
  FormMain_BarvyButAdd.Enabled:=true;
end;

function GetColorsetFromName(sName:string):string;
var i:Integer;
begin
  Result:='';
  for i:=0 to naColorset-1 do begin
    if(aColorset[i].sName=sName) then begin
      Result:=aColorset[i].sColors;
      i:=naColorset-1;
    end;
  end;
end;

function GetColorsetIndexFromName(sName:string):integer;
var i:Integer;
begin
  Result:=-1;
  for i:=0 to naColorset-1 do begin
    if(aColorset[i].sName=sName) then begin
      Result:=i;
      i:=naColorset-1;
    end;
  end;
end;

procedure ColorListOnClick(sender:TObject);
var i:integer;
    s,s1:string;
begin
  if(FormMain_BarvyList.ItemIndex>-1) then begin
    s:=aColorset[FormMain_BarvyList.ItemIndex].sColors;
    for i:=0 to COLOR_INDEX_ValuePerc do begin
      s1:=fetch(s,CRLF);
      //aiColorset[i]:=StrToInt('$'+s1);
      aiColorsetSwap[i]:=StrToInt('$'+SwapRB(s1));
    end;
    FormMain_BarvyEditName.Text:=aColorset[FormMain_BarvyList.ItemIndex].sName;
    bColorChange:=false;
    FormMain_BarvyButAdd.Enabled:=false;
    ShowColors();
  end;
end;

procedure ColorsetCopyToList;
var i,j:Integer;
begin
  FormMain_BarvyLabelSeznam.Caption:='Poet barevnch profil: '+IntToStr(naColorset)+' / '+IntToStr(MAX_COLORSET);
  j:=FormMain_BarvyList.ItemIndex;
  FormMain_BarvyList.Clear;
  for i:=0 to naColorset-1 do FormMain_BarvyList.Items.Add(aColorset[i].sName);
  if(j<0) and (FormMain_BarvyList.Items.Count>0) then j:=0;
  FormMain_BarvyList.ItemIndex:=j;
  ColorListOnClick(nil);
end;

procedure ColorButChangeOnClick(sender:TObject);
var i:integer;
    s:string;
begin
  if(FormMain_BarvyList.ItemIndex>-1) then begin
    s:='';
    for i:=0 to COLOR_INDEX_ValuePerc do begin
      s:=s+SwapRB(IntToHex(aiColorsetSwap[i],6))+CRLF;
    end;
    aColorset[FormMain_BarvyList.ItemIndex].sColors:=Trim(s);
    bColorChange:=false;
    ColorEnableButtons();
  end;
end;

procedure ColorButDelOnClick(sender:TObject);
var i,j:Integer;
begin
  j:=FormMain_BarvyList.ItemIndex;
  if(j>-1) then begin
    i:=GetColorsetIndexFromName(FormMain_BarvyList.Items[j]);
    for i:=i+1 to naColorset-1 do begin
      aColorset[i-1].sColors:=aColorset[i].sColors;
      aColorset[i-1].sName:=aColorset[i].sName;
      aColorset[i-1].iReferences:=aColorset[i].iReferences;
    end;
    naColorset:=naColorset-1;
    FormMain_BarvyList.Items.Delete(j);
    if(FormMain_BarvyList.Items.Count-1>=j) then FormMain_BarvyList.ItemIndex:=j
    else FormMain_BarvyList.ItemIndex:=j-1;
    ColorListOnClick(nil);
  end;
end;

procedure ColorButAddOnClick(sender:TObject);
var i:Integer;
    s:string;
begin
  s:='';
  for i:=0 to COLOR_INDEX_ValuePerc do begin
    s:=s+SwapRB(IntToHex(aiColorsetSwap[i],6))+CRLF;
  end;
  aColorset[naColorset].sName:=FormMain_BarvyEditName.Text;
  aColorset[naColorset].iReferences:=0;
  aColorset[naColorset].sColors:=Trim(s);
  FormMain_BarvyList.Items.Add(aColorset[naColorset].sName);
  naColorset:=naColorset+1;
  FormMain_BarvyList.ItemIndex:=FormMain_BarvyList.Items.Count-1;
  ColorListOnClick(nil);
end;

procedure InitColor;
begin
  //nastavime obsluhu pro talcitko na vyvolani funkce pro volbu barev
  FormMain_BarvyLabelMainBg.OnDblClick:=@ColorOnClick;
  FormMain_BarvyLabelMainText.OnDblClick:=@ColorOnClick;
  FormMain_BarvyLabelTitleBg.OnDblClick:=@ColorOnClick;
  FormMain_BarvyLabelTitleText.OnDblClick:=@ColorOnClick;
  FormMain_BarvyLabelHeaderBg.OnDblClick:=@ColorOnClick;
  FormMain_BarvyLabelHeaderText.OnDblClick:=@ColorOnClick;
  FormMain_BarvyLabelBlockBg.OnDblClick:=@ColorOnClick;
  FormMain_BarvyLabelBlockText.OnDblClick:=@ColorOnClick;
  FormMain_BarvyLabelValueBg.OnDblClick:=@ColorOnClick;
  FormMain_BarvyLabelValueText.OnDblClick:=@ColorOnClick;
  FormMain_BarvyLabelValueMax.OnDblClick:=@ColorOnClick;
  FormMain_BarvyLabelValueAvg.OnDblClick:=@ColorOnClick;
  FormMain_BarvyLabelValueMin.OnDblClick:=@ColorOnClick;
  FormMain_BarvyLabelValuePerc.OnDblClick:=@ColorOnClick;

  FormMain_BarvyList.OnClick:=@ColorListOnClick;
  FormMain_BarvyEditName.OnChange:=@NameOnChange;

  FormMain_BarvyButChange.OnClick:=@ColorButChangeOnClick;
  FormMain_BarvyButDel.OnClick:=@ColorButDelOnClick;
  FormMain_BarvyButAdd.OnClick:=@ColorButAddOnClick;

  //zalomeni radku hintu, pokud je potreba
  FormMain_BarvyLabelMainBg.Hint:=ReplaceString(FormMain_BarvyLabelMainBg.Hint,'<br>',CRLF);
  FormMain_BarvyLabelMainText.Hint:=ReplaceString(FormMain_BarvyLabelMainText.Hint,'<br>',CRLF);
  FormMain_BarvyLabelTitleBg.Hint:=ReplaceString(FormMain_BarvyLabelTitleBg.Hint,'<br>',CRLF);
  FormMain_BarvyLabelTitleText.Hint:=ReplaceString(FormMain_BarvyLabelTitleText.Hint,'<br>',CRLF);
  FormMain_BarvyLabelHeaderBg.Hint:=ReplaceString(FormMain_BarvyLabelHeaderBg.Hint,'<br>',CRLF);
  FormMain_BarvyLabelHeaderText.Hint:=ReplaceString(FormMain_BarvyLabelHeaderText.Hint,'<br>',CRLF);
  FormMain_BarvyLabelBlockBg.Hint:=ReplaceString(FormMain_BarvyLabelBlockBg.Hint,'<br>',CRLF);
  FormMain_BarvyLabelBlockText.Hint:=ReplaceString(FormMain_BarvyLabelBlockText.Hint,'<br>',CRLF);
  FormMain_BarvyLabelValueBg.Hint:=ReplaceString(FormMain_BarvyLabelValueBg.Hint,'<br>',CRLF);
  FormMain_BarvyLabelValueText.Hint:=ReplaceString(FormMain_BarvyLabelValueText.Hint,'<br>',CRLF);
  FormMain_BarvyLabelValueMax.Hint:=ReplaceString(FormMain_BarvyLabelValueMax.Hint,'<br>',CRLF);
  FormMain_BarvyLabelValueAvg.Hint:=ReplaceString(FormMain_BarvyLabelValueAvg.Hint,'<br>',CRLF);
  FormMain_BarvyLabelValueMin.Hint:=ReplaceString(FormMain_BarvyLabelValueMin.Hint,'<br>',CRLF);
  FormMain_BarvyLabelValuePerc.Hint:=ReplaceString(FormMain_BarvyLabelValuePerc.Hint,'<br>',CRLF);
end;
