
const TABMENU_END='Ukonen TABMENU';
      TABMENU_ERR='!chybny pocet TABMENU!';
type fTExpandCloseItem=function(index:integer;bExpandThis,bExpandNested:boolean):integer;

var bEnable:boolean; //vsechny ukladaci rutiny berou ohled na bEnable (priznak nepotlaceni '#//#')
    bPlugin: boolean;//prave je zpracovavan radek uvnitr pluginu, prikazy ukladat s poznamkou bPlugin beze zmeny
    iActualParseFile:Integer; //poradi parsovaneho souboru (od 1)

procedure InsertCommand(index:integer; Cmd:TypedefCommand);
var i:integer;
begin
 //udelame misto pro vlozeni prikazu
  if(naCommand>=MAX_COMMAND) then ShowMessage('ERROR: Pekroen poet pkaz, nelze pidat dal.')
  else begin
    if(index<0) then index:=0;
    for i:=naCommand-1 downto index do aCommand[i+1]:=aCommand[i];
    aCommand[index]:=cmd;
    naCommand:=naCommand+1;
  end;
end;

{
procedure AddCommand(sCmd,sPar:string;iCmdPar:Integer;bExpand,bErr:boolean); //ulozi prikaz do seznamu prikazu
begin
  if(naCommand+1>MAX_COMMAND) then begin
    ShowMessage('Pekroen maximln poet pkaz v TEMPLATE souborech.');
    GeoAbort();
  end;
  aCommand[naCommand].sCommand:=sCmd;
  aCommand[naCommand].sParam:=sPar;
  aCommand[naCommand].iCmdPar:=iCmdPar;
  aCommand[naCommand].iFile:=iActualParseFile-1;
  aCommand[naCommand].bPlugin:=bPlugin;
  aCommand[naCommand].bEnable:=bEnable;
  aCommand[naCommand].bExpand:=bExpand;
  aCommand[naCommand].bInvisible:=false;
  naCommand:=naCommand+1;
end;
}
procedure AddCommand(sCmd,sPar:string;iCmdPar:Integer;bExpand,bErr:boolean); //ulozi prikaz do seznamu prikazu
var cmd:TypedefCommand;
begin
  cmd.sCommand:=sCmd;
  cmd.sParam:=sPar;
  cmd.iCmdPar:=iCmdPar;
  cmd.iFile:=iActualParseFile-1;
  cmd.iBlockCmdPar:=-1;
  cmd.bPlugin:=bPlugin;
  cmd.bEnable:=bEnable;
  cmd.bExpand:=bExpand;
  cmd.bInvisible:=false;
  InsertCommand(naCommand,cmd);
end;

procedure DeleteCommand(index:integer);
var i,j:Integer;
begin
  //musi obslouzit i vlozene prikazy v souboru, pokud je mazan prikaz pro
  //vlozeni souboru, proto najdeme prvni platny prikaz za smazanym
  j:=aCommand[index].iFile;
  i:=index+1;
  if(aCommand[index].sCommand='INCLUDE_TEMPLATE') and (i<naCommand) then begin
    while (i<naCommand) and (aCommand[i].iFile<>j) do i:=i+1;
  end;
  j:=index;
  for i:=i to naCommand-1 do begin
    aCommand[j]:=aCommand[i];
    j:=j+1;
  end;
  naCommand:=j;
  //ShowMessage('CCCCC pocet:='+IntToStr(j));
end;

function IsExpanded(index:Integer):boolean; //zjisti, zda prikaz muze byt roz/zabalen
begin
  Result:=false;
  if(index>-1) then
    if(aCmdPar[aCommand[index].iCmdPar].sType='GROUP')
      or (aCmdPar[aCommand[index].iCmdPar].sType='PLUGIN') then Result:=true;
end;

function ParsePathFile(cmd,param:string;iParentIndex:Integer):boolean; //vraci priznak zpracovani radku se jmenem podrizeneho souboru
begin
  Result:=false;
  if(cmd='POSTINCLUDE') or (cmd='PREINCLUDE') or (cmd='INCLUDE_TEMPLATE')
    or (cmd='PLUGINSTART') or (cmd='INCLUDE') then begin
    if(naFiles>MAX_FILES) then begin
      ShowMessage('ERROR: pekroen poet vnoench soubor.'+CRLF+cmd+' '+param);
      GeoAbort();
    end
    else begin
      aFiles[naFiles].sCommand:=cmd;
      aFiles[naFiles].sPathFile:=param;
      aFiles[naFiles].bChange:=false;
      aFiles[naFiles].iParentIndex:=iParentIndex;
      naFiles:=naFiles+1;
    end;
  end;
  if(cmd='PLUGIN') then bPlugin:=true;
  if(cmd='PLUGINEND') then bPlugin:=false;
  if(cmd='INCLUDE_TEMPLATE') then Result:=true;  //bude treba vlozit soubor
end;

procedure ParseTemplate(sPath:string;iIndex:Integer);
var aRows:TStringList;
    s1,s2,s3:string;
    i,j:Integer;
begin
  //pokud je cesta relativni (vzdy vuci DATADIR), prevedem ji na absolutni
  bPlugin:=false;
  sPath:=RelToAbsFilename(sPath,GEOGET_DATADIR);
  {
  ShowMessage('sPath='+sPath+CRLF+
              'iIndex='+IntToStr(iIndex)+CRLF+
              'Souboru='+IntToStr(naFiles)+CRLF
              +'iActualParseFile='+IntToStr(iActualParseFile)
              );
  }
  if(not FileExists(sPath)) then begin
    ShowMessage('Pouit soubor neexistuje:'+CRLF+CRLF+sPath);
  end
  else begin
    aRows:=TStringList.Create();
    //nacte polozky template souboru do promennych
    aRows.LoadFromFile(sPath);
  //ShowMessage('KKKKK soubor: '+sPath+CRLF+'pocet radku: '+IntToStr(aRows.Count));
    for i:=0 to aRows.Count-1 do begin
      if(iActualParseFile<>iIndex+1) then begin
        iActualParseFile:=iIndex+1;
        SetProgressBar(0,aRows.Count-1,RegexReplace('.*\\',sPath,'',false));
        //SetProgressBar(0,aRows.Count-1,sPath);
      end;
      FormMain_MainProgress.Position:=i;
      s1:=RegexSubstitute('\s*(.*?)\ +(.*)',aRows[i],'$1'); //pro pikazy s parametry
      if(s1='') then s1:=RegexSubstitute('\s*(.+?)\s*',aRows[i],'$1'); //pro prikazy bez parametru
      s2:=RegexSubstitute('\s*(.*?)\ +(.*)',aRows[i],'$2');
      s3:='^'+s1+'$';
      //ShowMessage('HHHH'+CRLF+'s1: xx'+s1+'xx'+CRLF+'s2: '+s2+CRLF+'s3: '+s3+CRLF+'naCmdPar='+IntToStr(naCmdPar));
      for j:=0 to naCmdPar-1 do begin  //ulozime parametry prikazu
        if(RegexFind(s3,aCmdPar[j].sCommand)) then begin
          //ShowMessage('WWWW'+CRLF+'s1: '+s1+CRLF+'s2: '+s2+CRLF+'j='+IntToStr(j));
          if(sIncoding='cp1250') then s2:=UtfToAnsi(CharsetToUtf(s2,sIncoding));
          if(s1='INCODING') then sIncoding:=s2;
          AddCommand(s1,s2,j,true,false);
          j:=naCmdPar-1;
          s3:='';
        end;
      end;
      //zkusime prikazy, ktere nemaji pevny tvar, jen pevny zacatek (LANG_TAG_*, LANG_*)
      if(s3<>'') then begin
        if(pos('LANG_TAG_',s1)=1) then begin
          j:=FindIndexCmdParFromCmd('LANG_TAG_*');
          if(j>-1) then begin
            if(sIncoding='cp1250') then s2:=UtfToAnsi(CharsetToUtf(s2,sIncoding));
            AddCommand(s1,s2,j,true,false);
            s3:='';
          end;
        end
        else if(pos('LANG_',s1)=1) then begin
          j:=FindIndexCmdParFromCmd('LANG_*');
          if(j>-1) then begin
            if(sIncoding='cp1250') then s2:=UtfToAnsi(CharsetToUtf(s2,sIncoding));
            AddCommand(s1,s2,j,true,false);
            s3:='';
          end;
        end;
      end;
      //ulozime nezname prikazy (s priznakem komentare)
      if(s3<>'') then begin
        if(sIncoding='cp1250') then s2:=UtfToAnsi(CharsetToUtf(s2,sIncoding));
        AddCommand(aRows[i],'',0,true,true);
      end;
      //pokud je to prikaz pro vlozeni nejakeho souboru, poznacime to
      //a pokud je to vlozeni jineho template, vlozime vsechny jeho prikazy
      if(ParsePathFile(s1,s2,iIndex)) then begin  //zpracovani prikazu vkladajicich soubory
        ParseTemplate(aFiles[naFiles-1].sPathFile,naFiles-1) //zaclenime vkladany soubor
      end;
    end;
    aRows.Free;
  end;
end;

function IsCmdShow(index:integer):boolean; //je prikaz s indexem v aCommand zobrazen?
begin
  Result:=true;
  if(aCommand[index].bInvisible) then Result:=false;
  if(not FormMain_UvodCheckKomentar.checked)     //pokud je komentar a jsou skryty
    and (aCmdPar[aCommand[index].iCmdPar].sType='COMMENT') then Result:=false;
  if(FormMain_UvodCheckSoubor.checked)     //pokud je komentar a jsou skryty
    and (aCommand[index].iFile<>FormMain_MainListFiles.ItemIndex) then begin
    Result:=false;
    end;
  if(iStartCmd>-1) and (index<iStartCmd) and (FormMain_UvodCheckInit.checked) then Result:=false;
  {
  if(index=0) then begin
    ShowMessage('FFFFFF'+CRLF
      +'index prikazu v aCommand: '+IntToStr(index)+CRLF
      +'index souboru z aCommand: '+IntToStr(aCommand[index].iFile)+CRLF
      +'index vybraneho souboru: '+IntToStr(FormMain_MainListFiles.ItemIndex)+CRLF
      +'bInvisible: '+IntToStr(aCommand[index].bInvisible as Integer)+CRLF
      +'ChekedInit: '+IntToStr(FormMain_UvodCheckInit.checked as Integer)+CRLF
      +'iStartCmd: '+IntToStr(iStartCmd)+CRLF
      );
  end;
  }
end;

procedure CenterSelectedTemplate;
var i:integer;
begin
  i:=FormMain_UvodListTemplate.ItemIndex-13;
  if(i<0) then i:=0;
  FormMain_UvodListTemplate.TopIndex:=i;
end;

procedure CmdToList; //prekopiruje viditelne prikazy do listboxu
var i,j:integer;     //zohlednujeme vybrany soubor, zobrazeni komentaru a rozbalene bloky
    iIndex:integer;
begin
  iIndex:=FormMain_UvodListTemplate.ItemIndex; //aktualne vybrany prikaz si
  if(iIndex>=0) then iIndex:=aIndexCommand[iIndex]; //zapamatujeme (jako index do aCommand)
  FormMain_UvodListTemplate.Clear;
  j:=0;
  for i:=0 to naCommand-1 do begin
    if(IsCmdShow(i)) then begin
      FormMain_UvodListTemplate.Items.Add(aCommand[i].sCommand+' '+aCommand[i].sParam);
      aIndexCommand[j]:=i;
      //vybereme stejny prikaz jako byl vybran driv
      if(i=iIndex) then FormMain_UvodListTemplate.ItemIndex:=j;
      j:=j+1;
    end;
  end;
  if(FormMain_UvodListTemplate.ItemIndex<0) and (FormMain_UvodListTemplate.Items.Count>0) then
    FormMain_UvodListTemplate.ItemIndex:=0;
  CenterSelectedTemplate;//vyrolujeme seznam tak, aby byl vybrany radek pokud mozno uprostred
end;

//rozbali nebo zabali jednu polozku, vraci index dalsiho prikazu, -1=neslo rozbalit/zabalit
//pracuje rekurzivne, bExpand rika, jak zachazet s vnorenymi skupinovymi polozkami
function ExpandCloseItem(index:integer;bExpandThis,bExpandNested:boolean):integer;
var i:Integer;
begin
  Result:=-2;
  if(not IsExpanded(index)) then Result:=-1 //nelze rozbalit/zabalit
  else if((aCommand[index].sCommand<>'TABMENU') and
    (RegexFind('('+TABMENU_END+'|'+TABMENU_ERR+')',aCommand[index].sParam)))
    then Result:=-1 //nelze rozbalit/zabalit
  else begin
    aCommand[index].bExpand:=bExpandThis;
    for i:=index+1 to naCommand-1 do begin
      //jsme na konci?
      //ukoncene zalozka?
      case aCommand[index].sCommand of
        'TABMENU': if(aCommand[i].sCommand='TABMENU') then Result:=i;
        'INCLUDE_TEMPLATE': if(aCommand[i].iFile=aCommand[index].iFile) then Result:=i;
        'PLUGIN':  if(aCommand[i].sCommand='PLUGINEND') then begin
                     Result:=i;
                     aCommand[i].bInvisible:=(not bExpandThis);
                   end;
        TXT_BLOCK_TABLE:  if(aCommand[i].sCommand=TXT_BLOCK_STOP) then begin
                     Result:=i;
                     aCommand[i].bInvisible:=(not bExpandThis);
                   end;
        TXT_BLOCK_MAP:  if(aCommand[i].sCommand=TXT_BLOCK_STOP) then begin
                     Result:=i;
                     aCommand[i].bInvisible:=(not bExpandThis);
                   end;
        TXT_BLOCK_GRAPH:  if(aCommand[i].sCommand=TXT_BLOCK_STOP) then begin
                     Result:=i;
                     aCommand[i].bInvisible:=(not bExpandThis);
                   end;
        else begin ShowMessage('PPPPP Chybny vstupni prikaz skupiny.');
                   Result:=-1;
                   end;
      end; //konec case pro nalezeni konce skupiny, pokud Result<0, konec nenalezen
      if(Result<-1) then begin //vnitrni prikaz ve skupine
        aCommand[i].bInvisible:=(not bExpandThis);
        //obslouzime vnorene skupiny, pokud je to treba
        if(IsExpanded(i)) then i:=ExpandCloseItem(i,bExpandNested,bExpandNested);
      end;
      if(Result>-2) then i:=naCommand-1;
    end;
  end;
end;

procedure MarkColors; //nacte barvy do interni struktury, nahradi prikaz COLORS prikazem TXT_BLOCK_COLORS
var i:integer;
    sName:string;
begin
  //naplnime tabulky barev
  for i:=0 to naCommand-1 do begin
    sName:='';
    if(aCommand[i].sCommand='COLORS') or (aCommand[i].sCommand='#==#_COLORSET') then begin
      sName:=ColorsetSave(aCommand[i].sParam);
      aCommand[i].sCommand:=aCommand[i].sCommand;
      //if(aCommand[i].sCommand='COLORS') then aCommand[i].sCommand:=aCommand[i].sCommand
      //else  aCommand[i].sCommand:=TXT_BLOCK_COLORS;
      aCommand[i].sParam:=sName;
    end;
  end;
end;

procedure MarkPlugin;     //nacte informace o zalozkach
var i,iPlugin:integer;
    bPlugin:boolean;
begin
  SetProgressBar(0,naCommand-1,'Seskupen Plugin');
  bPlugin:=false;
  iPlugin:=0;
  for i:=0 to naCommand-1 do begin  //musime obslouzit i zanorene pluginy do pluginu
    FormMain_MainProgress.Position:=i;
    aCommand[i].bPlugin:=bPlugin;
    if(bPlugin) then aCommand[i].bInvisible:=bPlugin; //uvnitr pluginu je neviditelne, ostatni nechame
    if(aCommand[i].sCommand='PLUGINEND') then begin
      iPlugin:=iPlugin-1;
    end;
    if(aCommand[i].sCommand='PLUGIN') then begin
      iPlugin:=iPlugin+1;
      aCommand[i].bExpand:=false;      //skupinovy  prikaz neni expandovan
    end;
    bPlugin:=(iPLugin>0);
  end;
end;

procedure MarkIncludeTemplate;     //nacte informace o zalozkach
var i,iFile:integer;
    bInclude:boolean;
begin
  bInclude:=false;
  iFile:=-1;
  for i:=0 to naCommand-1 do begin  //musime obslouzit i zanorene pluginy do pluginu
    //vkladani konci na stejne urovni souboru jako ma prvni INCLUDE_TEMPLATE
    if(iFile=aCommand[i].iFile) then begin bInclude:=false; iFile:=-1; end;
    if(bInclude) then aCommand[i].bInvisible:=bInclude; //vsechny vnorene prikazy jsou neviditelne
    if(aCommand[i].sCommand='INCLUDE_TEMPLATE') then begin
      aCommand[i].bExpand:=false;      //skupinovy  prikaz neni expandovan
      if(iFile<0) then iFile:=aCommand[i].iFile; //zapamatujeme si soubor prvniho INCLUDE
      bInclude:=true;
    end;
  end;
end;

procedure MarkTags;   //nacte definice TAGu do interni struktury a upravi aCommand
var i,iLangTag:Integer;
    s,s1:string;
begin
  iLangTag:=FindIndexCmdParFromCmd('LANG_TAG_*');
  SetProgressBar(0,naCommand-1,'Vyhledn definice TAG');
  for i:=0 to naCommand-1 do begin
    FormMain_MainProgress.Position:=i;
    s1:=aCommand[i].sCommand;
    if(s1='DEFINETAG') then begin
      s:=RegexSplit('\s+',aCommand[i].sParam);
      s1:=fetch(s,CRLF);
      //ShowMessage('MMMMM Tag:'+s+CRLF+'delka='+IntToStr(length(s)));
      TagAdd(s1,ReplaceString(s,CRLF,' '),''); //viceslovni kategorii spojime dohromady
      DeleteCommand(i);
      i:=i-1;
    end;
    if(aCommand[i].iCmdPar=iLangTag) then begin
      s1:=copy(s1,10,length(s1));
      //ShowMessage('MMMMM Tag:'+s1+CRLF+'delak='+IntToStr(length(s1)));
      TagAdd(s1,'',aCommand[i].sParam);
      DeleteCommand(i);
      i:=i-1;
    end;
  end;
end;

procedure MoveCommandsIntoBlock(index:Integer); //najde predchazejici pikazy, ktere
var i,j,idx:Integer;  //patri k tomuto bloku a presune je dovnitr, koukne i na nastaveni barev za prikazem!
    s:string;
begin
  idx:=aCommand[index].iCmdPar; //hlavni vykonny prikaz bloku (tabulka, graf, mapa)
  s:=','+aCmdPar[idx].sElements+','; //seznam moznych presouvanych prikazu je v ELEMENTS
  j:=index;
  //hledame od predchoziho pocatku bloku do konce predchoziho bloku (nebo START)
  for i:=index-2 downto 0 do begin // prikaz pred hlavnim vykonnym prikazem bloku
    if(not aCommand[i].bPlugin) and
      (
        (aCommand[i].sCommand='START') //hledani ukoncime prikazem START
        or (aCommand[i].sCommand=TXT_BLOCK_STOP) //koncem predchozi skupiny
        or          //predchozim vykonnym prikazem
          ((aCmdPar[aCommand[i].iCmdPar].sType<>'SET')
            and (aCmdPar[aCommand[i].iCmdPar].sType<>'COMMENT')
            and (aCmdPar[aCommand[i].iCmdPar].sType<>'NORMAL')
          )
      ) then begin //ukoncime
      i:=0;
    end
    else begin
      if(pos(','+aCommand[i].sCommand+',',s)>0) then begin //presuneme prikaz do bloku
        aCommand[i].iFile:=aCommand[index].iFile; //ve stejnem souboru jako vykonny prikaz bloku
        aCommand[i].bInvisible:=true; //prikaz nebude videt, je sbalen
        aCommand[i].iBlockCmdPar:=idx;
        InsertCommand(j,aCommand[i]);
        j:=j-1; //dalsi prikaz prijde o pozici pred tento
        DeleteCommand(i);
      end;
    end;
  end;
end;

function GetBlockCommandFromType(typ:string):string;
begin
  Result:='';
  if(typ='TABLE') then Result:=TXT_BLOCK_TABLE
  else if(typ='MAP') then Result:=TXT_BLOCK_MAP
  else if(typ='GRAPH') then Result:=TXT_BLOCK_GRAPH
  else if(typ='APPEND_NUMBERS') then Result:=TXT_BLOCK_NUMBERS
  //else begin Result:=TXT_BLOCK_???; Result:='CmdPar.ini: chybn Type pro blokov pkaz'; end;
  ;
end;

procedure MarkGroups;  //preorganizuje aCommand, seskupi prikazy jedne skupiny k sobe
var i,idx:integer; //a "obali" je zacatkem a koncem skupiny
    cmd:TypedefCommand;
begin
  SetProgressBar(0,naCommand-1,'Seskupen pkaz');
  for i:=iStartCmd+1 to naCommand-1 do begin
    FormMain_MainProgress.Position:=i;
    //pokud je to skupinovy prikaz, obalime jej znackami
    if(aCmdPar[aCommand[i].iCmdPar].sElements<>'') then begin
      idx:=aCommand[i].iCmdPar;
      cmd.sError:='';
      cmd.sCommand:=GetBlockCommandFromType(aCmdPar[idx].sType);
      cmd.sParam:=aCommand[i].sCommand+' '+aCommand[i].sParam;
      cmd.iCmdPar:=FindIndexCmdParFromCmd(cmd.sCommand);
      if(cmd.iCmdPar<0) then begin
        cmd.sError:='CmdPar.ini: chybn Type pro blokov pkaz';
        //ShowMessage('ERROR: blokov pkaz (obsahuje Elements a nespravny Type): '+aCommand[i].sCommand+CRLF+'neznam blok: '+cmd.sCommand);
        cmd.iCmdPar:=0;
      end;
      cmd.iFile:=aCommand[i].iFile; cmd.bInvisible:=false; cmd.bEnable:=true;
      cmd.bPlugin:=false;           cmd.bExpand:=false;
      cmd.iBlockCmdPar:=-1; //aCommand[i].iCmdPar;
      InsertCommand(i,cmd);  //vlozime zacatek bloku
      aCommand[i+1].bInvisible:=true; //vlastni prikaz nebude videt (je zabaleny do uzavreneho bloku)
      aCommand[i+1].iBlockCmdPar:=aCommand[i+1].iCmdPar;
      cmd.sCommand:=TXT_BLOCK_STOP;
      cmd.sParam:='';
      cmd.iCmdPar:=FindIndexCmdParFromCmd(cmd.sCommand);
      cmd.iFile:=aCommand[i+1].iFile; cmd.bInvisible:=true;  cmd.bEnable:=true;
      cmd.bPlugin:=false;             cmd.bExpand:=false;
      cmd.iBlockCmdPar:=aCommand[i+1].iCmdPar;
      InsertCommand(i+2,cmd);  //vlozime konec bloku
      MoveCommandsIntoBlock(i+1);
      i:=i+2;
    end;
  end;
end;

procedure MarkNumbers; //nacte radky pridane do tabulky zajimavych cisel do interni struktury a upravi aCommand
var i,j:integer;
    s,sName,s1,s2,sL,sR:string;
    sNmb:TstringList;
begin
  SetProgressBar(0,naCommand-1,'Seskupen definic dk do SomeNumbers');
  if(aNumbers=nil) then aNumbers:=TStringList.Create()
  else aNumbers.Clear();
  sNmb:=TStringList.Create();
  for i:=0 to naCommand-1 do begin
    FormMain_MainProgress.Position:=i;
    j:=pos('LANG_NUMBERS_',aCommand[i].sCommand);
    if(j>0) then begin
      s:=copy(aCommand[i].sCommand,j+13,1000);
      sNmb.Add(s);
      sNmb.Add(aCommand[i].sParam);
      DeleteCommand(i); //vymazeme ho ze seznamu, upravovat to pujde jen pres zalozku
      i:=i-1;
    end;
    if(aCommand[i].sCommand='DEFINENUMBERS') then begin
      s:=aCommand[i].sParam;
      sName:=fetch(s,' ');
      s1:=fetch(s,' ');
      s2:=s;
      sL:=''; sR:='';
      for j:=0 to sNmb.Count-1 do begin //najdeme definice jmen
        if(s1=sNmb[j]) then sL:=sNmb[j+1];
        if(s2=sNmb[j]) then sR:=sNmb[j+1];
        j:=j+1;
        if(sL<>'') and (sR<>'') then j:=sNmb.Count-1;
      end;
      if(sL='') and (sR='') then
        ShowMessage('ERROR: Chybn definice DEFINENUMBERS '+s+CRLF+'nenalezen odpovdajc LANG_NUMBERS_*')
      else begin
        aNumbers.Add(sName);  //jmeno radku
        aNumbers.Add(s1); aNumbers.Add(sL); //jmeno a hodnota leveho sloupce
        aNumbers.Add(s2); aNumbers.Add(sR); //jmeno a hodnota praveho sloupce
      end;
      DeleteCommand(i); //vymazeme ho ze seznamu, upravovat to pujde jen pres zalozku
      i:=i-1;
    end;
  end;
  sNmb.Free();
end;

procedure MarkTabmenu;     //nacte informace o zalozkach
var i,j,iTabmenu:integer;
    s:string;
begin
  //projdeme a nacteme seznam moznych TABMENU
  SetProgressBar(0,naCommand-1,'Kontrola pkaz TABMENU');
  iStartCmd:=-1;
  if(aTabmenu=nil) then aTabmenu:=TStringList.Create()
  else aTabmenu.Clear();
  for i:=0 to naCommand-1 do begin
    FormMain_MainProgress.Position:=i;
    if(aCommand[i].sCommand='DEFINETABMENU') then aTabmenu.Add(aCommand[i].sParam);
    if(aCommand[i].sCommand='START') then begin iStartCmd:=i; j:=i; i:=naCommand-1; end; //dal nema smysl se koukat
  end;
  if(aTabmenu.Count>0) then aTabmenu.Add(TABMENU_END);
  //najdeme vsechny TABMENU a pouzijeme drive nactena jmena, abychom je oznacili "jmenem"
  iTabmenu:=-1;
  for i:=j to naCommand-1 do begin
    FormMain_MainProgress.Position:=i;
    if(aCommand[i].sCommand='TABMENU') then begin
      iTabmenu:=iTabmenu+1;
      //prikaz TABMENU bude videt/nevidet podle nadrizeneho bloku, proto nemenit
      //aCommand[i].bInvisible:=false;
      aCommand[i].bExpand:=false;
      if(iTabmenu<aTabmenu.Count) then s:=aTabmenu.Strings[iTabmenu]
      else begin
        s:=TABMENU_ERR;
        aCommand[i].sError:='Pebyten pkaz, vce TABMENU ne DEFINETABMENU';
      end;
      aCommand[i].sParam:=' # ('+s+')';
    end
    else if((iTabmenu>=0) and (iTabmenu<aTabmenu.Count)) then aCommand[i].bInvisible:=true;
  end;
end;

procedure MarkGroupCmds; //ulozeni skupinovych prikazu, priznak zabaleni/rozbaleni
var i:Integer;
begin
  MarkColors();
  MarkTags(); TagToList();
  MarkGroups();
  MarkNumbers();
  //nacist definovane promenne (SETVAR)
  //dalsi poradi musi byt zachovano, aby se spravne vyhodnotila neviditelnost
  MarkPlugin();
  MarkIncludeTemplate();
  MarkTabmenu();
  SetProgressBar(0,naCommand-1,'Kontrola parametr vech pkaz');
  for i:=0 to naCommand-1 do begin
    FormMain_MainProgress.Position:=i;
    //TABMENU netestujeme, je otestovan drive
    //ShwMessage('SSSSS nasledujici je chyba pri Test.cfg');
    if(aCommand[i].sCommand<>'TABMENU') then TestCommand(i); //zkontrolujeme vsechny prikazy
  end;
end;
