const STYLE_BKGCOLOR_SELECTED=$02880000;
      STYLE_BKGCOLOR_FOCUSED=$02ffffff;
      STYLE_COLOR_SELECTED=$02ffff00;
      STYLE_COLOR_DISABLED=$02888888;
      DBLCLICK_TIMER=300;
      
var  aBitmap:array [0..MAX_ICON] of TBitmap;
     iMSec:integer; //milisekundy posledniho kliku mysi
     fExpandCloseItem:fTExpandCloseItem;
     sLastElements:string;
     iLastRadio,iLastRadioItemIndex:Integer;
     bDeleteBlock:boolean;

function GetItemProp(iState:byte;iIcon:Integer;sType:string):TypedefShowProperty; //zjisti vlastnosti pisma vypisovane polozky
var i:integer;
begin
  //Spravne by melo byt iState:TOwnerDrawState, ale v enginu je to jako byte
  //iState bit 0=1 (1) ... vybrana polozka (odSelected)
  //           1=1 (2) ... zasedla polozka (odGrayed)
  //           2=1 (4) ... zakazana polozka (odDisabled)
  //           3=1 (8) ... zaskrtnuta polozka (odChecked)
  //           4=1 (16) .. focus je na listboxu (odCocused)
  //           6=1 (64) .. chybna polozka
  //iIcon - poradove cislo ikony, -1= bez ikony (promenna neni vyuzita, jen je
  //        vracena ve strukture zpet volajicimu)
  //
  // nastavit pismo
  Result:=aFontItem[0].rFont;
  Result.iIndex:=-1; //bez ikony
  for i:=0 to naFontItem do begin
    if(aFontItem[i].sName=sType) then begin
      Result:=aFontItem[i].rFont;
      Result.iIndex:=iIcon;  //ikona +, - nebo bez ikony
      i:=MAX_COLORTYPE;
    end;
  end;
  // vynutit styl, barvu, font (ve zvlastnich pripadech - vybrano, zakazano)
  if((iState  AND 1)=1) then begin
    Result.iBkgColor:=STYLE_BKGCOLOR_SELECTED;
    Result.iColor:=STYLE_COLOR_SELECTED;
  end;
  if((iState AND 4)=4) then Result.iColor:=STYLE_COLOR_DISABLED;
  if((iState AND 4)=4) then Result.iFontStyle:=[fsItalic];
end;

procedure ListDrawItem(list: TListBox; Index: Integer; Rect: TRect;State: byte;
  sText,sType:string;iIcon,iPosun:integer);
var
  rProp:TypedefShowProperty;
  Bitmap:TBitmap;
  RectSrc,RectTrg:TRect;
  x,y:integer;
  s:string;
begin
  rProp:=GetItemProp(state,iIcon,sType);
  with list.Canvas do begin
    Brush.Color:=rProp.iBkgColor;
    Font.Style:=rProp.iFontStyle;
    Font.Color:=rProp.iColor;
    FillRect(Rect);
    if(rProp.iIndex>=0) then begin
      Bitmap:=aBitmap[rProp.iIndex];
      RectSrc.Left:=0; RectSrc.Top:=0; RectSrc.Right:=Bitmap.Width; RectSrc.Bottom:=Bitmap.Height;
      RectTrg.Left:=Rect.Left+2+iPosun; RectTrg.Top:=Rect.Top+3;
      RectTrg.Right:=Rect.Left+2+iPosun+Bitmap.Width; RectTrg.Bottom:=Rect.Top+3+Bitmap.Height;
      BrushCopy(RectTrg,Bitmap,RectSrc,Bitmap.Canvas.Pixels[0,0]);	// zkopirovat bitmapu do Canvasu
      x:=Bitmap.Width;
      y:=Bitmap.Height;
    end
    else begin x:=9; y:=9; end;
    if(sText<>'') then sText:=CMT_SEPARATOR+sText;
    s:=list.Items[Index]+sText
      //+' (stav:'+IntToStr(State)+')'
      //+' iId='+IntToStr(Index)
      //+', iIdnex='+IntToStr(rProp.iIndex)
      //+', iBkgColor='+IntToStr(rProp.iBkgColor)
      ;
    TextOut(Rect.Left+(x+6)+iPosun,Rect.Top,s);
  end;
end;

procedure UvodListMozne_DrawItem(list: TWinControl; Index: Integer; Rect: TRect;
  State: byte {podle dokumentace je typu TOwnerDrawState, ale v enginu je byte});
var
  i,iIcon:integer;
  s:string;
begin
  if((Index>=0){ and (Index<5)}) then begin
    s:=FormMain_UvodListMozne.Items[Index];
    i:=FindIndexCmdParFromCmd(fetch(s,CMT_SEPARATOR));
    if(i<0) then i:=0; //pro pripad, ze nenajde, pouzijeme nahradni informace
    if((aCmdPar[i].sType='GROUP')) then iIcon:=ICON_PLUS
    else iIcon:=ICON_NONE;
    s:=aCmdPar[i].sShort;
    if(s='') then s:=aCmdPar[i].sComment;
    ListDrawItem(FormMain_UvodListMozne,Index,Rect,State,s,aCmdPar[i].sType,iIcon,0);
  end;
end;

procedure EnableButtons; //povoli nebo zakaze prislusna tlacitka
var i:integer;
    s:string;
    b,bBlock,bPlugin,bBlockStartStop:boolean;
begin
  i:=-1;
  if(FormMain_UvodListTemplate.ItemIndex>=0) then begin
    i:=aIndexCommand[FormMain_UvodListTemplate.ItemIndex];
    bBlock:=(aCommand[i].iBlockCmdPar<0);
    bPlugin:=aCommand[i].bPlugin;
    bBlockStartStop:=(aCommand[i].sCommand=TXT_BLOCK_STOP)
                  or (aCommand[i].sCommand=TXT_BLOCK_NUMBERS)
                  or (aCommand[i].sCommand=TXT_BLOCK_GRAPH)
                  or (aCommand[i].sCommand=TXT_BLOCK_MAP)
                  or (aCommand[i].sCommand=TXT_BLOCK_TABLE);
  end
  else begin bBlock:=false; bPlugin:=false; bBlockStartStop:=false; end;
  FormMain_UvodButDel.Enabled:=(FormMain_UvodListTemplate.ItemIndex>=0) and (not bPlugin) and (not bBlockStartStop);
  FormMain_UvodButAdd.Enabled:=(FormMain_UvodListMozne.ItemIndex>=0) and (not bPlugin);
  //prozatim nedovolime GROUP prikazy soupat
  FormMain_UvodButUp.Enabled:=(FormMain_UvodListTemplate.ItemIndex>0)
    and (bBlock) and (not bPlugin) and (not IsExpanded(i));
  FormMain_UvodButDown.Enabled:=(FormMain_UvodListTemplate.ItemIndex>=0)
    and (FormMain_UvodListTemplate.ItemIndex<FormMain_UvodListTemplate.Items.Count-1)
    and (bBlock) and (not bPlugin) and (not IsExpanded(i));
  FormMain_UvodButComment.Enabled:=(FormMain_UvodListMozne.ItemIndex>=0) and (not bPlugin) and (not bBlockStartStop);
  FormMain_UvodButFind.Enabled:=(FormMain_UvodListMozne.ItemIndex>=0);
  FormMain_UvodButFindNext.Enabled:=(FormMain_UvodListMozne.ItemIndex>=0);
  FormMain_UvodCheckInit.Enabled:=(iStartCmd>-1);

  FormMain_UvodButDemo.Enabled:=false;
  b:=false;
  i:=FindIndexCmdParFromTemplate();
  if(i>-1) then begin
    b:=(aCmdPar[i].iParams[1]>0);
    //if(aCmdPar[i].sType='GROUP') then begin //prozatim nedovolime GROUP prikazy soupat
      //FormMain_UvodButUp.Enabled:=false;
      //FormMain_UvodButDown.Enabled:=false;
    //end;
  end;
  FormMain_UvodButEdit.Enabled:=((FormMain_UvodListTemplate.ItemIndex>-1) and (b)
    and (not bPlugin) and (not bBlockStartStop));
  s:='';
  i:=FindIndexCmdParFromMozne();
  if(i>-1) then begin
    s:=aCmdPar[i].sDemo;
  end;
  FormMain_UvodButDemo.Enabled:=(s<>'');
  EnableMainButtons();
end;

procedure UvodListTemplate_DrawItem(list: TWinControl; Index: Integer; Rect: TRect;
  State: byte {podle dokumentace je typu TOwnerDrawState, ale v enginu je byte});
var
  i,iIcon,iPosun:integer;
  s:string;
begin
  if(Index>=0) then begin
    s:=FormMain_UvodListTemplate.Items[Index];
    i:=aCommand[aIndexCommand[Index]].iCmdPar;
    if(i<0) then i:=0; //pro pripad, ze nenajde, pouzijeme nahradni informace
    if(aCmdPar[i].sType='GROUP') or (aCmdPar[i].sType='PLUGIN') then begin
      if(aCommand[aIndexCommand[Index]].bExpand) then iIcon:=ICON_MINUS
      else iIcon:=ICON_PLUS;
    end
    else iIcon:=ICON_NONE;
    iPosun:=aFiles[aCommand[aIndexCommand[Index]].iFile].iDepth*14;
    //odsadit vnorene blokove prikazy
    if(aCommand[aIndexCommand[Index]].iBlockCmdPar>-1) then iPosun:=iPosun+14;
    if(aCommand[aIndexCommand[Index]].sError<>'') then
      ListDrawItem(FormMain_UvodListTemplate,Index,Rect,State,'','ERROR',iIcon,0)
    else if(aCommand[aIndexCommand[Index]].bPlugin) then
      ListDrawItem(FormMain_UvodListTemplate,Index,Rect,State,'','PLUGIN',iIcon,0)
    else ListDrawItem(FormMain_UvodListTemplate,Index,Rect,State,'',aCmdPar[i].sType,iIcon,iPosun);
  end;
end;

procedure UvodListMozneOnClick(sender:TObject);
var s:string;
    i:integer;
begin
  //zmenime TooTip na spravny text
  s:='';
  i:=FindIndexCmdParFromMozne();
  if(i>=0) then s:=aCmdPar[i].sComment;
  FormMain_UvodListMozne.Hint:=s;
  iLastRadioItemIndex:=FormMain_UvodListMozne.ItemIndex;
  EnableButtons;
end;

procedure ClickTimerStop;
begin
  ClickTimer.Enabled:=false;   //zastavit casovac
  iMSec:=24*60*60*1000; //prvni milisekunda dalsiho dne
end;

procedure UvodRadioCatOnClick(sender:TObject);
begin
  //protoze je tato metoda vyvolana i pri programove zmene ItemIndex!!!
  //zobrazime spravny seznam prikazu
  FormMain_UvodListMozne.Items:=aListboxCat[FormMain_UvodRadioCat.ItemIndex];
  if(FormMain_UvodListMozne.Items.Count>0) then FormMain_UvodListMozne.ItemIndex:=0
  else FormMain_UvodListMozne.ItemIndex:=-1;
  //ShowMessage('WWWWWW OnClick!!!!');
  iLastRadio:=FormMain_UvodRadioCat.ItemIndex;
  iLastRadioItemIndex:=FormMain_UvodListMozne.ItemIndex;
  UvodListMozneOnClick(nil); //nastavime spravny tooltip
end;

procedure SwitchToElements();
var i,j,iCategory,iCmdPar:Integer;
    s:string;
begin
  iCmdPar:=FindIndexCmdParFromTemplate();
  iCategory:=aCategory.IndexOfName('ACTUAL_GROUP');
  if(iCmdPar>-1) then begin
    i:=aIndexCommand[FormMain_UvodListTemplate.ItemIndex];
    //pokud je o zacatek bloku, zjistime hlavni prikaz skupiny
    if(aCmdPar[iCmdPar].sType='GROUP') then begin
      i:=i+1;
    end;
    iCmdPar:=aCommand[i].iBlockCmdPar;
    if(aCommand[i].iBlockCmdPar<>-1) and (aCommand[i].sCommand<>TXT_BLOCK_STOP) then begin
      //budeme neco delat, pokud je aktualne zobrazen spatny seznam elementu
      if(sLastElements<>aCmdPar[iCmdPar].sElements) then begin
        FormMain_UvodRadioCat.Enabled:=true; //aby se zmena v radiobuttonu provedla
        sLastElements:=aCmdPar[iCmdPar].sElements;
        aListboxCat[iCategory].Clear(); //vymazeme stary seznam
        //naplnime seznam prikazu prikazy obsazenymi v Elements, index prikazu je v iCmdPar
        s:=sLastElements;
        //pridame komentar
        j:=aListboxCat[iCategory].Add('#');
        while (s<>'') do aListboxCat[iCategory].Add(fetch(s,','));
        //radiobutton 'Aktualni skupina', a radiobutton zakaze, aby
        //neslo prepnout na jiny
        i:=iLastRadio;  //zapamatujeme si, protoze zmena ItemIndex vyvola OnCLick
        j:=iLastRadioItemIndex;
        //s:=sLastElements;
        FormMain_UvodRadioCat.ItemIndex:=iCategory;
        UvodRadioCatOnClick(nil);//vyvola se automaticky zmenou ItemIndex!!
                                 //ale protoze muze byt potlacen Radiobutton, vyvolame znovu
        iLastRadio:=i;        //vratime zapamatovane hodnoty
        iLastRadioItemIndex:=j;
        //sLastElements:=s;
        FormMain_UvodRadioCat.Enabled:=false;
        FormMain_UvodListMozne.ItemIndex:=iLastRadioItemIndex;
      end;
    end
    else begin //prepneme ze zobrazeni platnych elementu na puvodni radiobutton
      if(sLastElements<>'') then begin//jen pokud byly drive zobrazeny elementy
        sLastElements:='';
        aListboxCat[iCategory].Clear(); //vymazeme stary seznam
        FormMain_UvodRadioCat.Enabled:=true;
        FormMain_UvodRadioCat.ItemIndex:=iLastRadio;
        //UvodRadioCatOnClick(nil); //provede se automaticky zmenou ItemIndex!
        FormMain_UvodListMozne.ItemIndex:=iLastRadioItemIndex;
      end;
    end;
  end;
end;

procedure UvodListTemplateOnClick(sender:TObject);
var i:integer;
    s:string;
begin
  ClickTimerStop;
  i:=FormMain_UvodListTemplate.ItemIndex;
  if(i>=0) then begin
    i:=aIndexCommand[i];
    FormMain_MainListFiles.ItemIndex:=aCommand[i].iFile; //ukazeme soubor, z ktereho prikaz
                                             //je ale tim nenastavujeme Hint :-(
    s:=aCmdPar[aCommand[i].iCmdPar].sShort;
    if(aCommand[i].iCmdPar=0) and (aCommand[i].bPlugin) then s:='Pkaz pluginu';
    if(s='') then s:=aCmdPar[aCommand[i].iCmdPar].sComment;
    if(aCommand[i].sError<>'') then s:=s+CRLF+'ERROR: '+aCommand[i].sError;
    FormMain_UvodListTemplate.Hint:='Pkaz: '+aCommand[i].sCommand+CRLF
      +'Parametry: '+aCommand[i].sParam+CRLF+'Vznam: '+s;
  end;
  //pokud je treba, prepneme za prikazy povolene ve skupine
  SwitchToElements();
  EnableButtons;
  //ShowMessage('Click');
end;

procedure UvodButEditOnClick(sender:TObject);
var b:boolean;
    i,j:Integer;
begin
{$ifdef DEBUG} ProfileStart; {$endif}
  if(FormMain_UvodListTemplate.ItemIndex>-1) then begin
    b:=true;
    i:=FindIndexCmdParFromTemplate;
    j:=aIndexCommand[FormMain_UvodListTemplate.ItemIndex];
    //zkontrolujeme, zda je mozne jej upravovat primo
    if(b) and (pos('internal',aCmdPar[i].sCategory)>0) then begin
      ShowMessage('WARN: Tento pkaz nelze upravovat pmo, ale pes odpovdajc zloku.')
      b:=false;
    end;
    if(b) then begin
      ShowPage(FormMain_Pages,'TabEdit');
      InitEditParam();
    end;
  end;
end;

function SwapCommands(ind1,ind2:integer):boolean; //vraci priznak rozdilneho souboru
var cmd:TypedefCommand;
begin  //jak si poradit se zmenou souboru?
  Result:=(aCommand[ind1].iFile<>aCommand[ind2].iFile);
  if(Result) then ShowMessage('WARN: Pesun pkazu do jinho souboru!');
  cmd:=aCommand[ind2];
  aCommand[ind2]:=aCommand[ind1];
  aCommand[ind1]:=cmd;
end;

procedure UvodButUpOnClick(sender:TObject);
var i,j,k:integer;
    cmd:TypedefCommand;
    b:boolean;
begin  //zatim neumi pres sbalemou skupinu prikazu
  i:=aIndexCommand[FormMain_UvodListTemplate.ItemIndex];
  //najdeme prvni predchozi viditelny prikaz, ale nesmi to byt skupina
  //protoze do skupiny se pridava jen z praveho seznamu
  b:=false;
  j:=i;
  k:=FormMain_UvodListTemplate.ItemIndex;
  while (j>=0) and (not b) do begin
    j:=j-1;
    if(j>-1) then begin
      if((aCommand[j].bInvisible=false) and (aCommand[j].iBlockCmdPar=-1)
         and (aCommand[j].bPlugin=false)) then b:=true;
      if(aCommand[j].bInvisible=false) then k:=k-1; //o radek vys v zobrazenem seznamu
    end;
    //ShowMessage('JJJJ'+CRLF+'i='+IntToStr(i)+CRLF+'j='+IntToStr(j)+CRLF
    //  +'k='+IntToStr(k)+CRLF+'b='+IntToStr(b as Integer));
  end;
  if(b) then begin
    if(aCommand[i].iFile<>aCommand[j].iFile) then begin
      ShowMessage('WARN: Pesun pkazu do jinho souboru!');
      aCommand[i].iFile:=aCommand[j].iFile;
    end;
    cmd:=aCommand[i];
    DeleteCommand(i);
    InsertCommand(j,cmd);
    FormMain_UvodListTemplate.ItemIndex:=k;
    CmdToList();
    OnFileChange();
    EnableButtons();
  end;
end;

procedure UvodButDownOnClick(sender:TObject);
var i,j,k,ii:integer;
    cmd:TypedefCommand;
    b:boolean;
begin
  i:=aIndexCommand[FormMain_UvodListTemplate.ItemIndex];
  b:=false;
  j:=i;
  k:=FormMain_UvodListTemplate.ItemIndex;
  ii:=0; //neni neviditelny nebo skupinovy prikaz
  //najdeme prvni nasledujici viditelny prikaz
  while (j<naCommand) and (not b) do begin
    j:=j+1;
    if(j<naCommand) then begin
      if((aCommand[j].bInvisible=false) and (aCommand[j].bPlugin=false)
        and (aCommand[j].iBlockCmdPar=-1)
        and (not IsExpanded(j){aCmdPar[aCommand[j].iCmdPar].sType<>'GROUP'})) then b:=true
      //pokud neco preskakujeme, prijde zkoprirovat pred prvni viditelny prikaz
      //misto za nej
      else ii:=1
      ;
      if(aCommand[j].bInvisible=false) then k:=k+1; //o radek niz v zobrazenem seznamu
    end;
    //ShowMessage('JJJJ'+CRLF+'cmd='+aCommand[j].sCommand+CRLF+'i='+IntToStr(i)+CRLF+'j='+IntToStr(j)+CRLF
    //  +'k='+IntToStr(k)+CRLF+'b='+IntToStr(b as Integer));
  end;
  if(b) then begin
    if(cmd.iFile<>aCommand[j].iFile) then begin
      ShowMessage('WARN: Pesun pkazu do jinho souboru!');
      aCommand[i].iFile:=aCommand[j].iFile;
    end;
    cmd:=aCommand[i];
    DeleteCommand(i);
    InsertCommand(j-ii,cmd);
    //FormMain_UvodListTemplate.ItemIndex:=k-ii;
    CmdToList();
    FormMain_UvodListTemplate.ItemIndex:=k-ii;
    OnFileChange();
    EnableButtons();
  end;
end;

procedure MakeEmptyFile;
begin //pokud neni zadny otevreny soubor, inicializuje promenne vytvorenim fiktivniho
  if(naFiles=0) then begin
    aFiles[naFiles].sPathFile:='(nov soubor)';
    aFiles[naFiles].sCommand:='';
    aFiles[naFiles].iParentIndex:=-1;
    aFiles[naFiles].iDepth:=0;
    aFiles[naFiles].bChange:=false;
    FormMain_MainListFiles.Items.Add(aFiles[naFiles].sPathFile);
    FormMain_MainListFiles.ItemIndex:=0;
    naFiles:=naFiles+1;
  end;
end;

function SkipBeforeMainCmdGorup:integer; //vraci index hlavniho prikazu skupiny nebo -1
var j,ii:Integer;
begin;
  Result:=-1;
  j:=FormMain_UvodListTemplate.ItemIndex;
  if(j>-1) then begin
    ii:=aIndexCommand[j];
    //pokud je vkladano do skupiny, posuneme ukazatel pred hlavni prikaz skupiny a bude se vkladat za nej
    if(aCommand[ii].sCommand<>TXT_BLOCK_STOP) then begin
      //najdeme ukoncovaci prikaz skupiny (je rozbalena skupina a neni jeji konec)
      if((aCommand[ii].iBlockCmdPar<>-1) or (IsExpanded(ii))) then begin
        while(aCommand[ii].sCommand<>TXT_BLOCK_STOP) do begin
          ii:=ii+1;
          j:=j+1;      //dalsi zobrazeny radek
          if(aCommand[ii].iBlockCmdPar>-1) then Result:=aCommand[ii].iBlockCmdPar;
        end;
      end;
      //pokud byla skupina, posuneme prikaz pred hlavni prikaz skupiny
      if(aCommand[ii].sCommand=TXT_BLOCK_STOP) then begin //bylo posouvano
        ii:=ii-2;
        j:=j-2;
        FormMain_UvodListTemplate.ItemIndex:=j; //za tento prikaz (tedy pred hlavni prikaz skupiny) se bude vkladat
      end
      else Result:=-1;
    end;
  end;
end;

function SkipBehindPlugin:boolean; //vraci priznak preskoceni
var ii,j:Integer;
begin
  Result:=false;
  //pokud je to prvni prikaz pluginu a je rozbalen, musim preskocit
  //az na jeho posledni prikaz
  j:=FormMain_UvodListTemplate.ItemIndex;
  if(j>-1) then begin
    ii:=aIndexCommand[j];
    //pokud je vkladano do pluginu, posuneme ukazatel pred hlavni prikaz skupiny a bude se vkladat za nej
    if(aCommand[ii].sCommand='PLUGIN') or  (aCommand[ii].bPlugin) then begin
      while(ii<naCommand-1) and (aCommand[ii].sCommand<>'PLUGINEND') do begin
        if(aCommand[ii].bInvisible=false) then j:=j+1;
        ii:=ii+1;
        Result:=true;
      end;
      FormMain_UvodListTemplate.ItemIndex:=j;
    end;
  end;
end;

procedure UvodButAddOnClick(sender:TObject);
var i,j,ii,iBlockCmd:integer;
    cmd:TypedefCommand;
    s:string;
begin
  i:=FormMain_UvodListMozne.ItemIndex;
  iBlockCmd:=-1;
  if(i>-1) then begin
    MakeEmptyFile;
    s:=aCmdPar[FindIndexCmdParFromMozne].sCategory;
    if(pos('internal',s)>0) then
      ShowMessage('WARN: Tento pkaz nelze vkldat pmo,'+CRLF
       +'je soust bloku pkaz vkldanch a upravovanch'+CRLF
       +'jako celek pes odpovdajc zloku.'+CRLF+CRLF+s)
    else begin
      if(not SkipBehindPlugin()) then begin
        iBlockCmd:=SkipBeforeMainCmdGorup(); //vrati -1 nebo index hlavniho prikazu skupiny
      end;
      //zkontrolovat, zda nejde o hlavni prikaz skupiny pokud ano, obalit ho zacatkem a koncem bloku
      s:=FormMain_UvodListMozne.Items[i];
      cmd.sCommand:=fetch(s,' ');
      s:=cmd.sCommand;
      cmd.sParam:='';
      i:=FindIndexCmdParFromCmd(cmd.sCommand);
      j:=FormMain_UvodListTemplate.ItemIndex+1; //toto bude index vlozeneho prikazu na Listboxu
      if(FormMain_UvodListTemplate.ItemIndex<0) then ii:=0
      else ii:=aIndexCommand[j];
      //pridame zacatek skupiny, pokud je to potreba
      if(aCmdPar[i].sElements<>'') then begin
        cmd.sCommand:=GetBlockCommandFromType(aCmdPar[i].sType);
        cmd.sParam:=s;
        cmd.iCmdPar:=FindIndexCmdParFromCmd(cmd.sCommand);
        cmd.iFile:=FormMain_MainListFiles.ItemIndex;
        cmd.bPlugin:=false;
        cmd.bEnable:=true;
        cmd.bExpand:=true;
        cmd.bInvisible:=false;
        cmd.iBlockCmdPar:=-1;
        InsertCommand(ii,cmd);
        iBlockCmd:=i;
        ii:=ii+1;
        j:=j+1;
      end;
      //pridame vlastni prikaz
      cmd.sCommand:=s;
      cmd.sParam:='';
      cmd.iCmdPar:=i;
      cmd.iFile:=FormMain_MainListFiles.ItemIndex;
      cmd.bPlugin:=false;
      cmd.bEnable:=false;
      cmd.bExpand:=true;
      cmd.bInvisible:=false;
      cmd.iBlockCmdPar:=iBlockCmd;
      InsertCommand(ii,cmd);
      //pridame konec skupiny, pokud je to potreba
      if(aCmdPar[i].sElements<>'') then begin
        cmd.sCommand:=TXT_BLOCK_STOP;
        cmd.sParam:='';
        cmd.iCmdPar:=FindIndexCmdParFromCmd(cmd.sCommand);
        cmd.iFile:=FormMain_MainListFiles.ItemIndex;
        cmd.bPlugin:=false;
        cmd.bEnable:=true;
        cmd.bExpand:=false;
        cmd.bInvisible:=false;
        cmd.iBlockCmdPar:=i;
        InsertCommand(ii+1,cmd);
      end;
      CmdToList();
      OnFileChange();
      FormMain_UvodListTemplate.ItemIndex:=j;
      TestCommand(aIndexCommand[FormMain_UvodListTemplate.ItemIndex]);
      UvodListTemplateOnClick(nil);
      //vyvolame editaci pridaneho radku (pokud ma mit parametr)
      UvodButEditOnClick(nil);
    end;
  end;
end;

procedure UvodButDelOnClick(sender:TObject);
var i,j:Integer;
begin
  j:=FormMain_UvodListTemplate.ItemIndex;
  if(j>-1) then begin
    i:=aIndexCommand[FormMain_UvodListTemplate.ItemIndex];
    if(aCommand[i].iCmdPar=aCommand[i].iBlockCmdPar) and (not bDeleteBlock) then begin
      if(6=MessBox('Vymaznm hlavnho pkazu skupiny dojde ke smazn cel skupiny.'+CRLF
        +'Opravdu skupinu vymazat?'+CRLF,'WARN: smazn skupiny',4)) then begin
        while(i>-1) //najdeme prvni prikaz skupiny
          and (aCommand[i].sCommand<>TXT_BLOCK_TABLE) and (aCommand[i].sCommand<>TXT_BLOCK_MAP)
          and (aCommand[i].sCommand<>TXT_BLOCK_GRAPH) and (aCommand[i].sCommand<>TXT_BLOCK_NUMBERS) do begin
          i:=i-1;
          FormMain_UvodListTemplate.ItemIndex:=FormMain_UvodListTemplate.ItemIndex-1;
        end;
        bDeleteBlock:=true;
        while(aCommand[aIndexCommand[FormMain_UvodListTemplate.ItemIndex]].sCommand<>TXT_BLOCK_STOP) do begin
          UvodButDelOnClick(nil);
        end;
        UvodButDelOnClick(nil); //jeste smazem koncovy prikaz skupiny
        bDeleteBlock:=false;
      end;
    end
    else begin
      DeleteCommand(i);
      CmdToList();
      if(j>FormMain_UvodListTemplate.Items.Count-1) then
        FormMain_UvodListTemplate.ItemIndex:=FormMain_UvodListTemplate.Items.Count-1;
      OnFileChange();
      if(FormMain_UvodListTemplate.ItemIndex>FormMain_UvodListTemplate.Items.Count-1) then
        FormMain_UvodListTemplate.ItemIndex:=FormMain_UvodListTemplate.Items.Count-1;
      UvodListTemplateOnClick(nil);
    end;
  end;
end;

procedure UvodListTemplateOnRightClick(sender:TObject);
var i,j,iTypes,iNames:integer;
    sTypes,sNames:string;
begin
  i:=FormMain_UvodListTemplate.ItemIndex;
  if(i>=0) then begin
    i:=aIndexCommand[i];
    with aCmdPar[aCommand[i].iCmdPar] do begin
      if(aParamTypes=nil) then iTypes:=0 else iTypes:=aParamTypes.Count;
      if(aParamNames=nil) then iNames:=0 else iNames:=aParamNames.Count;
      for j:=0 to iTypes-1 do sTypes:=sTypes+'|'+aParamTypes.strings[j];
      sTypes:=copy(sTypes,2,length(sTypes));  //odparat prvni svislitko
      for j:=0 to iNames-1 do sNames:=sNames+'|'+aParamNames.strings[j];
      sNames:=copy(sNames,2,length(sNames));  //odparat prvni svislitko
    end;
    with aCommand[i] do begin
      ShowMessage('Parametry oznaceneho radku:'+CRLF+CRLF
        +'index radku: '+IntToStr(i)+CRLF
        +'prikaz: '+sCommand+CRLF
        +'index prikazu v aCommand: '+IntToStr(aIndexCommand[FormMain_UvodListTemplate.ItemIndex])+CRLF
        +'parametry: '+sParam+CRLF
        +'poradi souboru: '+IntToStr(iFile)+CRLF
        +'iBlockCmdPar: '+IntToStr(iBlockCmdPar)+' (index prikazu v CmdPar hlavniho prikazu skupiny)'+CRLF
        +'bPlugin: '+IntToStr(bPlugin as Integer)+CRLF
        +'bEnable: '+IntToStr(bEnable as Integer)+CRLF
        +'bInvisible: '+IntToStr(bInvisible as Integer)+CRLF
        +'bExpand: '+IntToStr(bExpand as Integer)+CRLF
        +'sError: '+sError+CRLF
        +'---------------------------------'+CRLF
        +'poradi prikazu v aCmdPar: '+IntToStr(iCmdPar)+CRLF
        +'typ prikazu: '+aCmdPar[iCmdPar].sType+CRLF
        +'kategorie: '+aCmdPar[iCmdPar].sCategory+CRLF
        +'parametru min/max: '+IntToStr(aCmdPar[iCmdPar].iParams[0])+'/'+IntToStr(aCmdPar[iCmdPar].iParams[1])+CRLF
        +'typy parametru (pocet): '+sTypes+' ('+IntToStr(iTypes)+')'+CRLF
        +'jmena parametru (pocet): '+sNames+' ('+IntToStr(iNames)+')'+CRLF
        +'pouziti promennych GgStatu: '+aCmdPar[iCmdPar].sGsVariables+CRLF
      );
    end;
  end;
end;

procedure UvodListTemplateOnDblClick(sender:TObject);
var i,j:integer;
    //b:boolean;
    s:string;
begin
  ClickTimerStop;
  i:=FormMain_UvodListTemplate.ItemIndex;
  if(i>=0) then begin
    i:=aIndexCommand[i];
    //pokud je mozne prikaz rozbalit, rozbalime, jinak skocime na jeho editaci
    j:=ExpandCloseItem(i,not aCommand[i].bExpand,false); //vnitrni skupiny vzdy zabalene
    if(j=-1) then begin
      if(aCommand[i].bPlugin) then ShowMessage('WARN: Pkazy pluginu nelze upravovat.')
      else if(aCmdPar[aCommand[i].iCmdPar].iParams[1]>0) then UvodButEditOnClick(nil)
      else ShowMessage('WARN: Nelze upravit, pkaz nem mt dn parametry.');
    end
    else begin
      CmdToList();
      s:=aCmdPar[aCommand[i].iCmdPar].sShort;
      if(s='') then s:=aCmdPar[aCommand[i].iCmdPar].sComment;
      FormMain_UvodListTemplate.Hint:='Pkaz: '+aCommand[i].sCommand+CRLF
        +'Parametry: '+aCommand[i].sParam+CRLF+'Vznam: '+s;
      UvodListTemplateOnClick(nil); //aby se zobrazil spravne seznam moznych prikazu
    end;
  end;
end;

procedure UvodTimerOnClick(sender:TObject);
var i,i1:integer;
    h,m,s,ms:word;
begin
  ClickTimer.Enabled:=false;
  DecodeTime(now,h,m,s,ms);
  i:=(((h*60)+m)*60+s)*1000+ms;
  i1:=i-iMSec;
  iMSec:=i;
  if(i1<DBLCLICK_TIMER) and (i1>0) then begin //cas od posledniko kliknuti?
    UvodListTemplateOnDblClick(sender)
    ;
  end
  else begin
    ClickTimer.Interval:=DBLCLICK_TIMER;
    ClickTimer.Enabled:=true;
  end;
end;

procedure UvodListTemplateOnMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer); //simulace kliknuti pravym/strednim mysitkem
begin
  case Button of
  mbLeft :  UvodTimerOnClick(Sender);
  mbRight:  UvodListTemplateOnRightClick(nil);
  //mbMiddle: ShowMessage('MIDDLE button');
  end;
end;

procedure UvodCheckKomentarOnClick(sender:TObject);
begin
  CmdToList();
  EnableButtons();
end;

procedure UvodCheckSouborOnClick(sender:TObject);
begin
  CmdToList();
  EnableButtons();
end;

procedure UvodCheckInitOnClick(sender:TObject);
begin
  CmdToList();
  EnableButtons();
end;

procedure UvodButFindNextOnClick(sender:TObject);
var i,j:integer;
begin
  if(sFind='') then begin
    sFind:=InputBox('Hledn textu','Hledan text',sFind);
  end;
  if(sFind<>'') then begin
    j:=FormMain_UvodListTemplate.ItemIndex;
    for i:=j+1 to FormMain_UvodListTemplate.Items.Count-1 do begin
      if(pos(Uppercase(sFind),Uppercase(FormMain_UvodListTemplate.Items[i]))>0) then begin
        FormMain_UvodListTemplate.ItemIndex:=i;
        UvodListTemplateOnClick(nil);
        CenterSelectedTemplate;
        i:=FormMain_UvodListTemplate.Items.Count-1;
        j:=-1;
      end;
    end;
    //nenalezeno do konce souboru, budeme hledat od zacatku
    if(j=FormMain_UvodListTemplate.ItemIndex) then begin
      for i:=0 to j do begin
        if(pos(Uppercase(sFind),Uppercase(FormMain_UvodListTemplate.Items[i]))>0) then begin
          FormMain_UvodListTemplate.ItemIndex:=i;
          UvodListTemplateOnClick(nil);
          CenterSelectedTemplate;
          i:=j;
        end;
      end;
    end;
    if(j=FormMain_UvodListTemplate.ItemIndex) then ShowMessage('Nenalezeno: '+sFind)
    else UvodListTemplateOnClick(nil);
  end;
end;

procedure UvodButFindOnClick(sender:TObject);
begin
  sFind:='';
  UvodButFindNextOnCLick(sender);
end;

procedure UvodButExpandOnClick(sender:TObject);
var b:boolean;
    i:integer;
begin
  b:=(sender=FormMain_UvodButExpand);
  for i:=0 to naCommand-1 do begin
    if(IsExpanded(i)) then begin
      i:=ExpandCloseItem(i,b,b);
      if((i<0) or (i>naCommand-1)) then i:=naCommand-1;
    end;
  end;
  CmdToList();
end;

procedure UvodButDemoOnClick(sender:TObject);
var i:Integer;
    s:string;
begin
  i:=FindIndexCmdParFromMozne();
  if(i>-1) then begin
    s:=aCmdPar[i].sDemo;
    if(s<>'') then RunShell(GetGgStatDir+'\GgStatDoc\'+s)
    else ShowMessage('ERROR: Nen definovn odkaz na pklad v dokumentaci.');
  end;
end;

procedure UvodButCommentOnClick(sender:TObject);
var i,j:Integer;
    s,s1:string;
begin //!!!!!!!!!!! pozor, nejsou obslouzeny skupinove prikazy !!!!!!!!!!!!!!
  i:=FormMain_UvodListTemplate.ItemIndex;
  if(i>-1) then begin
    j:=aIndexCommand[i];
    s:=aCommand[j].sCommand;
    s1:=fetch(s,' ')
    if(s1='#//#') then begin aCommand[j].sCommand:=s; s1:=fetch(s,' '); end
    else begin aCommand[j].sCommand:='#//# '+aCommand[j].sCommand; s1:='#//#'; end;
    FormMain_UvodListTemplate.Items[FormMain_UvodListTemplate.ItemIndex]:=aCommand[j].sCommand+' '+aCommand[j].sParam;
    aCommand[j].iCmdPar:=FindIndexCmdParFromCmd(s1);
    OnFileChange();
    UvodListTemplateOnClick(FormMain_UvodListTemplate);
  end;
end;

function Base64ToBitmap(str:string):TBitMap;
var s:string;
    stream:TMemoryStream;
begin
  stream:=TMemoryStream.Create;
  try
    s:=DecodeBase64(str);
    stream.Write(s,Length(s));
    stream.Position:=0;
    Result:=TBitMap.Create();
    Result.LoadFromStream(stream);
  finally
    stream.free;
  end;
end;

procedure InitUvod;
begin
  //nacteme bitmapy
  aBitmap[0]:=Base64ToBitmap(BMPICO_MINUS);
  aBitmap[1]:=Base64ToBitmap(BMPICO_PLUS);
  aBitmap[2]:=Base64ToBitmap(BMPICO_CHANGE);
  fExpandCloseItem:=@ExpandCloseItem; //pro rekurzivni rozbalovani/zabalovani skupin

  //vytvorime casovac pro kontrolu DblClicku
  ClickTimer:=TTimer.Create(FormMain_UvodListTemplate);
  ClickTimerStop;

  FormMain_UvodButDoc.Visible:=false;

  //nastavit prvni zalozku jako aktivni
  ShowPage(FormMain_Pages,'TabUvod');
  {
  while (FormMain_Pages.ActivePage.PageIndex<>0) do begin
    //1. parametr true ... nasledujici stranka, false ... predchozi
    //2. parametr true ... bere v uvahu jen visible stranky
    FormMain_Pages.SelectNextPage(false,true);
  end;
  }
  FormMain_UvodListTemplate.OnDrawItem:=@UvodListTemplate_DrawItem;
  FormMain_UvodListMozne.OnDrawItem:=@UvodListMozne_DrawItem;
  FormMain_UvodRadioCat.OnClick:=@UvodRadioCatOnClick;
  FormMain_UvodListMozne.OnClick:=@UvodListMozneOnClick;
  //FormMain_UvodListTemplate.OnClick:=@UvodListTemplateOnClick;
  //FormMain_UvodListTemplate.OnClick:=@UvodTimerOnClick; //Click/DblClick
  ClickTimer.OnTimer:=@UvodListTemplateOnClick; //pokud casovac vyprsi, spousti se Click
  FormMain_UvodListTemplate.OnMouseDown:=@UvodListTemplateOnMouseDown; //kontroluje prave, leve mysitko, Click/DblClick
  FormMain_UvodCheckKomentar.OnClick:=@UvodCheckKomentarOnClick;
  FormMain_UvodCheckSoubor.OnClick:=@UvodCheckSouborOnClick;
  FormMain_UvodCheckInit.OnClick:=@UvodCheckInitOnClick;
  FormMain_UvodButFind.OnClick:=@UvodButFindOnClick;
  FormMain_UvodButFindNext.OnClick:=@UvodButFindNextOnClick;
  FormMain_UvodButExpand.OnClick:=@UvodButExpandOnClick;
  FormMain_UvodButEdit.OnClick:=@UvodButEditOnClick;
  FormMain_UvodButAdd.OnClick:=@UvodButAddOnClick;
  FormMain_UvodButDel.OnClick:=@UvodButDelOnClick;
  FormMain_UvodButUp.OnClick:=@UvodButUpOnClick;
  FormMain_UvodButDown.OnClick:=@UvodButDownOnClick;
  FormMain_UvodButClose.OnClick:=@UvodButExpandOnClick;
  FormMain_UvodButDemo.OnClick:=@UvodButDemoOnClick;
  FormMain_UvodButComment.OnClick:=@UvodButCommentOnClick;
  EnableButtons;
end;
