var
  bDebug:boolean;            //nastaveno jen u me (podle Gordici)
  
  sIncoding:string;          //vstupni kodovani sablony
  aFiles:TypedefFiles;       //seznam pouzitych souboru
  naFiles:Integer;           //pocet souboru v poli
  //aColorset:TypedefColorset; //seznam barevnych schemat
  //naColorset:Integer;        //skutecny pocet definovanych barevnych schemat
  aCommand:array[0..MAX_COMMAND] of TypedefCommand;   //seznam prikazu ze vsech template souboru
  naCommand:Integer;         //skutecny pocet prikazu
  
  aCategory:TStringList;     //seznam kategorii (radiobuttony nad listboxem moznych prikazu)
  aListboxCat:array[0..MAX_CATEGORY] of TStringList; //seznam prikazu v kategoriich
  aIndexCommand:array[0..MAX_COMMAND] of Integer; //index prikazu v listboxu do aCommand

  aFontItem:array [0..MAX_COLORTYPE] of TypedefColorType; //parametry fontu pro zobrazeni v listboxu s prikazy Template souboru
  naFontItem:Integer;         //pocet vyuzitych typu zobrazeni
  
  aCmdPar:TypedefCmdPar;      //seznam moznych prikazu a jejich moznosti (nacteno z INI)
  naCmdPar:Integer;           //pocet vyuzitych prikazu
  
  aColorset:array[0..MAX_COLORSET] of TypedefColorset;
  naColorset:Integer;

  aTag:array[0..MAX_TAG] of TypedefTag;
  naTag:Integer;
  
  aNumbers:TStringList;        //seznam definovanych radku v tabulce zajimavych cisel

  aEditParams:TStringList;    //seznam parametru prikazu pro zalozku Editace prikazu
  
  aTabmenu:TStringList;       //seznam definovanych TABMENU
  
  ClickTimer:TTimer;          //casovac pro odliseni clicku a dblclicku
  
  sFind:string;               //posledni hledany text
  iStartCmd:Integer;          //index nacteneho prikazu START
  
procedure InitTemplateVars;   //inicializace promennych pro nove nacteni Template souboru
begin
  sIncoding:='cp1250';        //predpokladame vstup v ANSI
  naFiles:=0;
  naColorset:=0;
  naCommand:=0;
  naTag:=0;
end;

procedure FreeVars(global:boolean); //uvolnime alokovanou pamet, kterou potreboval formular
var i:integer;
begin
  //ShowMessage('Uklid');
  if(global) then begin    //globalne pouzivane promenne (parametry prikazu z INI, ...)
    if(aCategory<>nil) then aCategory.Free();
    for i:=0 to MAX_CATEGORY do begin if(aListboxCat[i]<>nil) then aListboxCat[i].Free; end;
    for i:=0 to MAX_CMDPARAM do begin
      if(aCmdPar[i].aParamTypes<>nil) then aCmdPar[i].aParamTypes.Free;
      if(aCmdPar[i].aValues<>nil) then aCmdPar[i].aValues.Free;
      if(aCmdPar[i].aParamNames<>nil) then aCmdPar[i].aParamNames.Free;
    end;
    if(aTabmenu<>nil) then aTabmenu.Free();
    if(aEditParams<>nil) then aEditParams.Free();
              if(ClickTimer<>nil) then ClickTimer.Free();
              if(aNumbers<>nil) then aNumbers.Free();
    naFontItem:=0;
    naCmdPar:=0;
  end;
  //promenne zavisle na Template souboru
  InitTemplateVars();
end;

